/*
 * Stuff that is needed all over the place.
 */

/* Defines the size for temp[] arrays used here and there...*/
#define HR_BUFFER_SIZE 1024

/* These are usually needed */
#define FONT8X8   "font8x8.pbm"
#define PTRBITMAP "pointer.ilbm"

/* Used in some places to scale up integers. DO NOT CHANGE!*/
#define SCALE 16

/* Just to make sure these are defined...*/
#define   MIN(a,b)   ((a < b)?(a):(b))
#define   MAX(a,b)   ((a > b)?(a):(b))
/* Distance between two points. (taken from angband). */
#define DISTANCE(x1, y1, x2, y2) \
   (( ((abs((y1) - (y2)) + abs((x1) - (x2))) << 1) - \
   ( (abs((y1) - (y2)) > abs((x1) - (x2))) ? abs((x1) - (x2)) : \
   abs((y1) - (y2)))) >> 1)


/* Puts 4 unsigned chars into an int */
#define CHARS2INT(a) ((unsigned int)((((unsigned char)(*(a+3)))<<24)| \
                                     (((unsigned char)(*(a+2)))<<16)| \
                                     (((unsigned char)(*(a+1)))<<8)| \
                                     (((unsigned char)(*(a  ))))))

/* Centers a line of text. */
#define HR_CENTER(x,y,color,bcolor,text,font,flags) \
      hr_monowrite((x)-strlen(text)*4,y,color,bcolor,text,font,flags)


/* For checking mouse keys.*/
#define HR_LMB (hr_mouse.button & MOUSE_LEFTBUTTON)
#define HR_MMB (hr_mouse.button & MOUSE_MIDDLEBUTTON)
#define HR_RMB (hr_mouse.button & MOUSE_RIGHTBUTTON)

/* Some names for true/false to keep source nicer looking.*/
#define YES           1
#define NO            0
/* Flags NONE...*/
#define NONE          0

/*Flags for buttons, fonts etc... */
#define ENABLED            1
#define SWITCH             2
#define PRESSED            4
#define INVISIBLE          8
#define ACCEPTS_INPUT      16
#define HSLIDER            32
#define VSLIDER            64
#define HOTKEY_PRESSED     128
#define INVISIBLE_HOTKEY   256
#define NO_TAB_CYCLE       512
#define OLD_DEFAULT_BUTTON 1024
#define HILITE             2048
#define NO_DELAY           4096
#define STRING_EDITED      8192

/* Slider flags */
#define SLIDER_XNEG         1
#define SLIDER_YNEG         2
#define SLIDER_GET_XVALINT  4
#define SLIDER_GET_YVALINT  8
#define SLIDER_SET_XVALINT  16
#define SLIDER_SET_YVALINT  32

/* Flags for bitmaps etc */
#define GFX_MONO          1
#define GFX_256COLOR      2
#define GFX_24BPALETTE    4
#define GFX_COMPILED      8
#define GFX_SINGLECOLBGR  16
#define GFX_INCLUDEZERO   32
#define GFX_BRITEST       64
#define GFX_DARKEST       128
#define GFX_NOBMAPPALETTE 256

/* Windows. */
#define WINDOW_STORED   1
#define WINDOW_CLIPPING 2
#define WINDOW_NOBORDER 4
#define WINDOW_INNERBOX 8

/* Input handler */
#define LMB_PRESSED    1
#define LMB_RELEASED   2
#define RMB_PRESSED    4
#define RMB_RELEASED   8
#define AMB_PRESSED    16
#define AMB_RELEASED   32
#define KBD_PRESSED    256
#define KBD_RELEASED   512
#define MENU_ENABLED   1024
#define NO_EDITING     2048
#define WAIT_EVENT     4096
#define IGNORE_HOTKEYS 8192


/* Bob flags */
#define BOB_INITIALIZED 128
/* Bob update modes...*/
#define BOB_INIT       0
#define BOB_INITONLY   1
#define BOB_SMART      2
#define BOB_DUMB       3
#define BOB_REMOVE     4
#define BOB_REMOVEONLY 5
#define BOB_NOIMG      6

/* These are hr_update_button() */
#define UPDATE_GFXONLY   0
#define UPDATE_INDEX     1
#define UPDATE_FLAGS     2
#define UPDATE_FONT      3
#define UPDATE_COLORS    4
#define UPDATE_TEXT      5
#define UPDATE_TEXT2     6
#define UPDATE_BITMAP    7
#define UPDATE_BITMAP2   8
#define UPDATE_X1        9
#define UPDATE_Y1        10
#define UPDATE_X2        11
#define UPDATE_Y2        12
#define UPDATE_PARENT    13
#define UPDATE_HOTKEY    14
#define UPDATE_EXTRAS    15

/* Screen flags*/
#define SCREEN_VIRTUAL     1
#define SCREEN_NOCLIP      2
#define SCREEN_VIRTUALONLY 4
