/*
 * IFF ILBM support.
 * DOES NOT WORK WITH COMPRESSED IMAGES... blah! FIX!
 * Add proper error handling/checkinf dflisdfjksdfa FIX
 */

#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <unistd.h>
#include <string.h>

#include <hr_defines.h>
#include <hr_general.h>
#include <hr_bobs.h>
#include <hr_bitmaps.h>


/* Reads an IFF-ILBM image from disk, uncompresses it if necessary
 * and then converts it to chunky mode. Returns pointer to
 * bitmap, or NULL if an error occurred.
 * Note that unlike read_ppm(), color (0,0,0) is allocated in palette.*/
struct hr_bitmap *hr_read_ilbm(unsigned char *name,int flags){
	FILE *fp;
	unsigned char temp[HR_BUFFER_SIZE],*t1,*t2;
	struct hr_bitmap *bmap=NULL;
	int c,x,y,i,p,l,z,pixel_offset;
	int planes=0,compression=0,pad=0,error=1;
	/* Space for needed chunks.*/
	unsigned char *cmap=NULL;
	unsigned char *bmhd=NULL;
	unsigned char *body=NULL,*ubody=NULL;
	/* Open the file. The file is parsed in one pass.*/
	if((fp=fopen(name,"r"))){
		temp[4]=0;
		/* Is this IFF file at all?*/
		fread(temp,1,4,fp);
		if((strncmp(temp,"FORM",4)==0)){
			/* Skip FORM length info.. :-)  Lame. */
			fseek(fp,4,SEEK_CUR);
			/* Check that chunkID ILBM is found.*/
			fread(temp,1,4,fp);
			if((strncmp(temp,"ILBM",4)==0)){
				bmap=hr_create_bitmap(NULL,NULL,0,0,0,flags|GFX_24BPALETTE);
				/* LOPETUSEHTO IMEEEEEEEEEEEeeeeeeeeeeeeeeeeeeee! FIX! */
				error=0;
				while(body==NULL) {
					/* Now read the chunks, one by one.
					 * All chunks except BMHD,CMAP,CAMG & BODY are ignored.*/
					/* Chunk name.*/
					fread(temp,1,4,fp);
					/* Chunk len.*/
					l=((fgetc(fp)<<24)|
						(fgetc(fp)<<16)|
						(fgetc(fp)<<8)|
						(fgetc(fp)));
					/* Make sure len is EVEN.*/
					if(l%2)
					  ++l;
					if((strncmp(temp,"BMHD",4)==0)){
						bmhd=malloc(l);
						fread(bmhd,1,l,fp);
						/* Chunk contents:
						 * WideHighXorgYorgPlMkCoPdTranAsptPagwPagh
						 * Width Height Xorigin Yorigin Planes Mask Compression
						 * Pad Transparency? Aspect? Pagewidth Pageheight )
						 */
						/* Width and height. */
						bmap->width=((*(bmhd)<<8) |
										 (*(bmhd+1)));
						bmap->height=((*(bmhd+2)<<8) |
										  (*(bmhd+3)));
						
						planes=*(bmhd+8);
						compression=*(bmhd+10);
						pad=*(bmhd+11);
						free(bmhd);
					}
#if 0
					else if((strncmp(temp,"CAMG",4)==0)){
						/* Contents:
						 * ViewMode (4bytes) */
						unsigned char *camg;
						int viewmode=0;
						camg=malloc(l);
						fread(camg,1,l,fp);
						viewmode=((*(camg)<<24)|
									 (*(camg+1)<<16)|
									 (*(camg+2)<<8)|
									 (*(camg+3)));
						free(camg);
					}
#endif
					else if((strncmp(temp,"CMAP",4)==0)){
						/* Contains rgbrgbrgb-values. 8bits per color component.
						 * Color zero is contained, even tho color 0 is usually
						 * ignored by most funcs (transparent) */
						cmap=malloc(l);
						fread(cmap,1,l,fp);
					}
					else if((strncmp(temp,"BODY",4)==0)){
						/* Contains (compressed) interleaved bitmap data.*/
						body=malloc(l);
						fread(body,1,l,fp);
						/* Uncompress if necessary.*/
						if(compression==1){
							/* Space for uncompressed body.*/
							ubody=malloc(((bmap->width)*(bmap->height)*planes)/8);
							p=0;
							for(i=0;i<l;i++){
								x=(signed char)(*(body+i));
								if((x<0)&&(x>-128)) {
									/* Compressed */
									y=(unsigned char)(*(body+(++i)));
									for(c=0;c<=(-x);c++)
									  *(ubody+(p++))=y;
								}
								else if (x>=0){
									/* Uncompressed */
									for(c=0;c<=x;c++)
									  *(ubody+(p++))=(unsigned char)(*(body+(++i)));
								}
								/* -128 is a NOP */
							}
							/* Recalc value of l, swap pointer to body.*/
							l=(p-1);
							free(body);
							body=ubody;
						}
						/*1bit per pixel. Used for fonts and stuff.*/
						if(flags & GFX_MONO)
						  bmap->data=malloc(1+(bmap->width)*(bmap->height)/8);
						/* Normal 8bits per pixel format.*/
						else if (flags & GFX_256COLOR)
						  bmap->data=malloc((bmap->width)*(bmap->height));

						i=pixel_offset=0;
						/* Width of one scanline in bytes.*/
						z=l/(bmap->height)/planes;
						/* Convert planar->chunky */
						for(y=0;y<(bmap->height);y++){
							for(x=0;x<(bmap->width);x++){
								c=0;
								for(p=0;p<planes;p++){
									if(((unsigned char)(*(body+(y*l/(bmap->height))+
																 (p*z)+(x/8)))) &
										(128>>(x%8)))
									  c|=(1<<p);
								}
								/* Store the converted value.*/
								if(flags & GFX_256COLOR)
								  *(bmap->data+(i++))=(unsigned char)c;
								else if ((c) && (flags & GFX_MONO)){
									/*Set the bit...*/
									*((bmap->data)+pixel_offset/8)|=
									  (128>>(pixel_offset%8));
									++pixel_offset;
								}
							}
						}
						free(body);
						/* Now the time-consuming part. Convert the image to
						 * format in which only colors that are used are
						 * stored in palette, and in which there are no "holes".
						 * temp[] array is used as conversion table
						 * Color 0 is always copied as 0.*/
						for(x=0;x<256;x++)
						  temp[x]=0;
						bmap->colors=1;		/* transparent... */
						t1=(bmap->data);
						t2=ubody=malloc((bmap->width)*(bmap->height));
						for(l=0;l<(bmap->width)*(bmap->height);l++){
							if(*t1){
								/* Non-zero pixels are checked. */
								/* If this is a new color,
								 * Inc # of colors and mark in temp[]
								 * what color replaces this color from now on.*/
								if(!temp[*t1])
								  temp[*t1]=(unsigned char)((bmap->colors)++);
							}
							*t2=temp[*t1];
							++t1;
							++t2;
						}
						/* Copy only used colors to bmap->palette.*/
						bmap->palette=malloc((bmap->colors)*3);
						/* Transparent color */
						memcpy(bmap->palette,cmap,3);
						/* Non-transparent colors */
						for(l=1;l<256;l++){
							if(temp[l]){
								*(bmap->palette+temp[l]*3  )=*(cmap+l*3  );
								*(bmap->palette+temp[l]*3+1)=*(cmap+l*3+1);
								*(bmap->palette+temp[l]*3+2)=*(cmap+l*3+2);
							}
						}
						free(cmap);
						/* Get rid of the original image and replace
						 * it with the "color compressed" image.*/
						free(bmap->data);
						bmap->data=ubody;
					}
					else {
						/* Skip chunk.*/
						fseek(fp,l,SEEK_CUR);
					}
				}
				/* Now modify palette and/or image, if some weird
				 * screenmode was specified in CAMG chunk.*/
				/* Add stuff here. FIX!*/
				/* Amiga specifics:
				 * 0x8000=HAM
				 * 0x4=LACE
				 * 0x0800=HAM
				 * 0x80=HALFBRITE
				 */
				/* Add checks. If bmap sucks in one way or another,
				 * delete it. FIX!*/
			}
		}
		fclose(fp);
	}
	else
	  printf("Error opening IFF ILBM file %s.\n",name);
	
	/* Kewlness */
	if(error)
	  return NULL;
	else
	  return bmap;
}
