/*
 *	Mouse support.
 */

#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <unistd.h>

#include <hr_defines.h>
#include <hr_bitmaps.h>
#include <hr_bobs.h>
#include <hr_general.h>
#include <hr_ilbm.h>


struct {
	int   flags;
	int   button;
	int   x;
	int   y;
	struct hr_bob *bob;
} hr_mouse;



/* Initializes mouse.*/
void hr_init_mouse() {
	unsigned char tmp[HR_BUFFER_SIZE];
	sprintf(tmp,"%s%s",hr.datapath,PTRBITMAP);
	hr_mouse.bob=hr_create_bob(0,hr_mouse.x,hr_mouse.y,0,0,
										hr_read_ilbm(tmp,GFX_256COLOR),
										NONE);
	hr_recolor_bitmap(hr_mouse.bob->bitmap,11,NONE);
}


/* This updates the stuff in mouse structure
 * and inits/draws/removes pointer.*/
void hr_update_mouse(int flags,int mode) {
	/* Get new mouse event ---------------------------------------------*/
	if(flags & WAIT_EVENT)
	  mouse_waitforupdate();
	else
	  mouse_update();
	/* Update mouse structure data -------------------------------------*/
	hr_mouse.x=mouse_getx();
	hr_mouse.y=mouse_gety();
	hr_mouse.button=mouse_getbutton();
	/* Update pointer --------------------------------------------------*/
	hr_update_bob(hr_mouse.bob,hr_mouse.x,hr_mouse.y,NULL,mode);
}
