/*
 * Parses args. Taken from man page
 * GNU                       April 25, 1993                        3
 * GETOPT(3)           Linux Programmer's Manual           GETOPT(3)
 */


#define OPTION_CHARACTERS "habc:d:012"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>


/* Return 1 if the calling proggie should quit. */
/* ADD POINTERZ HERE! */
int hr_parse_args(int argv,unsigned char **argv) {
	int c;
	int digit_optind = 0;
	int this_option_optind = optind ? optind : 1;
	int option_index = 0;
	static struct option long_options[] = {
		  {"help",0, 0,'h'},
		  {"add", 1, 0, 0},
		  {"long",0, 0, 0},
		  {"args",1, 0, 0},
		  {"here",0, 0, 0}
	};
	
	while(1) {
		this_option_optind = optind ? optind : 1;
		c = getopt_long(argc,argv,OPTION_CHARACTERS,
							 long_options,&option_index);
		/* No more args */
		if(c == -1)
		  break;
		switch(c)  {
		 case 'h':
			/* Always print usege with -h or --help flag! */
			printf("Usage: %s [options]\n",argv[0]);
			return 1;
			break;
		 case 0:
			printf("option %s",long_options[option_index].name);
			if(optarg)
			  printf(" with arg %s",optarg);
			printf("\n");
			break;
		 case '0':
		 case '1':
		 case '2':
			if(digit_optind != 0 && digit_optind != this_option_optind)
			  printf("digits occur in two different argv-elements.\n");
			digit_optind = this_option_optind;
			printf("option %c\n",c);
			break;
		 case 'a':
			printf("option a\n");
			break;
		 case 'b':
			printf("option b\n");
			break;
		 case 'c':
			printf("option c with value `%s'\n",optarg);
			break;
		 case 'd':
			printf("option d with value `%s'\n",optarg);
		 case '?':
			break;
		 default:
			printf("?? getopt returned character code 0%o ??\n",c);
		}
	}
	/* Go through non-option ARGV-elements */
	if(optind<argc) {
		while(optind<argc)
		  printf("%s ",argv[optind++]);
		printf("\n");
	}
	return 0;
}
