/*
 *	Zones a la Amos
 */

#include <stdlib.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <string.h>

#include <unistd.h>

#include <hr_defines.h>
#include <hr_general.h>
#include <hr_windows.h>

struct hr_zone{
	struct hr_zone *next;
	unsigned int index;
	int flags;
	struct hr_window *parent_window;
	int x1;
	int y1;
	int x2;
	int y2;
};


/* Gets rid of all zones. */
void hr_delete_all_zones() {	
	struct hr_zone *p,*op;
	p=hr.firstzone;
	while(p!=NULL) {
		op=p;
		p=p->next;
		free(op);
	}
	hr.firstzone=NULL;
}


/* Creates a zone. Returns pointer to the new zone. */
struct hr_zone *hr_set_zone(unsigned int index,
									 int x1,int y1,int x2,int y2) {
	struct hr_zone *p=hr.firstzone;
	if(p==NULL)
		hr.firstzone=p=malloc(sizeof(struct hr_zone));
	else {		
		while(p->next!=NULL) {			
			p=p->next;
		}
		p->next=malloc(sizeof(struct hr_zone));
		p=p->next;
	}	
	p->next=NULL;
	p->index=index;
	p->flags=ENABLED;
	p->x1=MIN(x1,x2);
	p->y1=MIN(y1,y2);
	p->x2=MAX(x1,x2);
	p->y2=MAX(y1,y2);
	p->parent_window=hr.active_window;
	return p;
}

/* Returns pointer to zone under coordinates x,y
 * or NULL if no button is there.*/
struct hr_zone *hr_get_zone(int x,int y,unsigned int index) {
	struct hr_zone *p;
	p=hr.firstzone;
	while(p!=NULL) {			
		if((p->flags & ENABLED) &&
			(p->parent_window == hr.active_window) &&
			(((p->x1 <=x) &&
			  (p->x2 >=x) &&
			  (p->y1 <=y) &&
			  (p->y2 >=y))||
			 ((index>0)&&
			  (p->index==index))))
		  return p;
		p=p->next;
	}
	return NULL;
}
