/*
 *	Tykkipeli 2
 *	Weapon/shield selection during game
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <unistd.h>

#include <defines.h>
#include <tp2.h>
#include <game_screen.h>
#include <players.h>
#include <weapons.h>
#include <shields.h>
#include <info_windows.h>
#include <control_panel.h>
#include <shield_defines.h>
#include <control_panel_defines.h>

#include <hr_mouse.h>
#include <hr_bobs.h>
#include <hr_buttons.h>
#include <hr_zones.h>
#include <hr_fonts.h>
#include <hr_defines.h>
#include <hr_general.h>
#include <hr_input_handler.h>
#include <hr_keyboard.h>
#include <hr_screens.h>

/* # of visible lines in item list*/
#define MAX_ITEMS_ON_SCREEN 17
#define SCROLL_UP    101
#define SCROLL_DOWN  102
#define SCROLL_DELAY 10000


int active_item_border(){
	struct hr_zone *zp;
	/* Get current zone.*/
	zp=hr_get_zone(hr_mouse.x,hr_mouse.y,0);
	/* Tell hr_input_handler() to exit if pointer is on scroll zone.*/
	if(zp!=NULL){
		if(((zp->index)==SCROLL_UP)||
			((zp->index)==SCROLL_DOWN))
		  return 1;
	}
	/* Return 1 if mouse has been moved from one zone to another. */
	if(zp!=NULL){
		if((zp->index)!=buffer[0])
		  return 1;
	}
	else if(buffer[0]>0)
	  return 1;
	return 0;
}


/* Active weapon/Shield selection */
void change_active_item(struct player *p,int m) {
	struct hr_zone *zp,*ozp;
	struct hr_button *b,*sb;
	struct weapon_list *wl,**ownedw=NULL;
	struct shield_list *sl,**owneds=NULL;
	unsigned char tmp[BUFFER_SIZE];
	int l1,l2,l,lx,yl,oyl,c,selection_made=0,bflags;
	int mode_change,visible;

	/* l1 and l2 are amounts of weapons/shields currently OWNED.
	 * ownedw and owneds contain pointers to blah blah... FIX comment */
	/* Realloccing sucketh.. */
	l1=l=0;
	wl=p->weapons;
	while(wl!=NULL){
		if((wl->amount)!=0){
			++l1;
			ownedw=realloc(ownedw,(sizeof(struct weapon_list *)*l1));
			*(ownedw+l++)=wl;
		}
		wl=wl->next;
	}
	l2=l=0;
	sl=p->shields;
	while(sl!=NULL){
		/* Note: The (None) shield is included in this list even tho
		 * none are really "owned" */
		if((sl->type->index==CHARS2INT("None"))||((sl->amount)>0)){
			++l2;
			owneds=realloc(owneds,(sizeof(struct shield_list *)*l2));
			*(owneds+l++)=sl;
		}
		sl=sl->next;
	}
	/* ready to roll */
	
	/* Save game screen.*/
	hr_delete_all_zones();
	hr_delete_all_buttons();
	save_game_screen();	
	
	/* Open selection screen*/
   hr_screen_open(G320x200x256,NONE);
	gl_setpalette(game_palette);
#if 0
	/* Not necessary...*/
	hr_default_palette();
#endif
	temp_colors->color2=(p->darkcolor);
	hr_textbox(2,2,248,13,hr.font8x8,temp_colors,p->name,PRESSED|ENABLED);
	hr_bevelbox(0,0,319,199,hr.def_colors,NONE);
	b=hr_create_button(1,250,2,317,13,
							 hr.font8x8,hr.def_colors,
							 NULL,"Change",ENABLED);
	hr_bevelbox(2,15,248,197,hr.def_colors,PRESSED);
	hr_bevelbox(260,15,317,197,hr.def_colors,PRESSED);

	hr_set_zone(SCROLL_UP,0,0,249,1);	   /* Scroll up */
	hr_set_zone(SCROLL_DOWN,0,198,249,199);/* Scroll down */
	for(l=0;l<=17;l++)				
	  hr_set_zone(l+1,4,16+l*10,246,25+l*10);	/* Selection zones */
	/* Slider bar */
	sb=hr_create_button(2,250,15,258,197,
							  hr.font8x8,hr.def_colors,
							  NULL,NULL,VSLIDER|ENABLED|PRESSED|NO_TAB_CYCLE);
	hr_clearkey();
	hr_input_handler(NULL,NULL,AMB_RELEASED);
	/* Loop until mouse button is clicked. */
	yl=0;oyl=yl-1;zp=ozp=NULL;mode_change=1;
	while(!(selection_made)) {
		while(!(selection_made)) {			
			/* Redraw list. First init buttons and stuff. */
			if((oyl!=yl)||(mode_change)) {
				if(mode_change){
					mode_change=0;
					/* Slider */
					free(sb->extras);
					l=((m==0)?(l1):(l2))-MAX_ITEMS_ON_SCREEN;
					visible=4;					/* FIX! Calc correct value. */
					sb->extras=hr_create_slider(VSLIDER|SLIDER_GET_YVALINT|
														 SLIDER_SET_YVALINT,
														 0,0,0,0,NULL,
														 l,visible,
														 yl,0,&yl);
					/* Buttonzen */ 
					bflags=ENABLED;
					hr_update_button(1,0,UPDATE_FLAGS,&bflags);
					hr_update_button(1,0,UPDATE_TEXT,(m==0)?("Weapons"):("Shields"));
				}
				/* Update slider. If slider was used, it automagically updates
				 * yl.*/
				hr_update_button(0,sb,UPDATE_GFXONLY,NULL);
				/* Clear the name/amoung fields.*/
				gl_fillbox(3,16,245,181,0);
				gl_fillbox(261,16,56,181,0);
				/* Go through owned weapons/shields.*/
				for(l=yl,lx=0;l<((m==0)?(l1):(l2));l++,lx++) {
					/* Break out of the loop if screen is already full */
					if(lx>MAX_ITEMS_ON_SCREEN)
					  break;
					/* Only print weap/shield info if it fits on screen.*/
					/* Using these makes the source a bit more readable*/
					if(m==0)
					  wl=*(ownedw+l);
					else
					  sl=*(owneds+l);
					/* Only print weapon info if the current weapon is owned.*/
					if(( (m==0)&&((wl->amount)!=0) )||
						( (m==1)&&(((sl->amount)>0)||(l==0)) )) {
						/* Default color is BLACK */
						c=2;
						/* Print current active weap/shield in WHITE*/
						if(((m==0)&&(p->active_weapon)==(wl->type))||
							((m==1)&&(p->active_shield)==(sl->type)))
						  c=1;
						/* Print weap/shield name */
						strcpy(tmp,(m==0)?(wl->type->name):(sl->type->name));
						tmp[29]=0;
						hr_monowrite(6,17+lx*10,c,0,tmp,hr.font8x8,NONE);
						/* Print weap/shield amount */
						if(m==0){
							if((wl->amount)<0)
							  strcpy(tmp,"Inf.");
							else
							  sprintf(tmp,"%d",wl->amount);
						}
						else{
							if((yl+l)==0)
							  /* (None) */
							  sprintf(tmp,"-");
							else
							  sprintf(tmp,"%d%%",
										 ((sl->amount)*100)/(sl->type->efficiency));
						}
						hr_monowrite(314-strlen(tmp)*8,17+lx*10,c,0,tmp,
										 hr.font8x8,NONE);
					}
				}
				oyl=yl;
				usleep(SCROLL_DELAY);
			}
			
			/* Store current zone number to buffer[] */
			if(zp!=NULL)
			  buffer[0]=(unsigned char)(zp->index);
			else
			  buffer[0]=0;
			/* Get button & zone etc*/
			b=hr_input_handler(NULL,&active_item_border,
									 KBD_PRESSED|AMB_PRESSED);
			/* Check if the player wants to abort */
			if(HR_RMB)
			  selection_made=1;
			else {
				zp=hr_get_zone(hr_mouse.x,hr_mouse.y,0);
				if((HR_LMB) && (zp!=NULL)){
					if((zp->index)<100){
						/* Check if new weap/shield is selected */
						l=yl+(zp->index)-1;
						if(l<((m==0)?(l1):(l2))) {
							c=-1;
							/* The weapon/shield selected is the 
							 * (yl+(zp->index))'th OWNED item.
							 * Just get pointer number l from array...*/
							if(m==0) {
								/* Weapons */
								wl=*(ownedw+l);
								p->active_weapon=wl->type;
							}
							else {
								/* Shields */
								sl=*(owneds+l);
								p->active_shield=sl->type;
							}
							selection_made=1;
							oyl=-666;
						}
					}
				}
				b=hr_input_handler(b,NULL,AMB_RELEASED);
				zp=hr_get_zone(hr_mouse.x,hr_mouse.y,0);
				/* Buttons */
				if(b!=NULL){
					switch(b->index){
					 case 1:
						mode_change=1;
						m=((m==0)?(1):(0));
						yl=0;
						/* :-) Make sure the list is redrawn */
						oyl=-666;
						break;
#if 0
					 case 2:
						/* Slider*/
						break;
#endif
					}
				}
				/* Item box */
				if(ozp!=zp){
					/* Remove old borders.*/
					if(ozp!=NULL){
						if(((ozp->index)<100) &&
							((ozp->index)-1<((m==0)?(l1):(l2)))){
							gl_line(ozp->x1,ozp->y1,ozp->x2,ozp->y1,0);
							gl_line(ozp->x2,ozp->y1,ozp->x2,ozp->y2,0);
							gl_line(ozp->x1,ozp->y1,ozp->x1,ozp->y2,0);
							gl_line(ozp->x1,ozp->y2,ozp->x2,ozp->y2,0);
						}
					}
					/* Draw new borders*/
					if(zp!=NULL){
						if(((zp->index)<100) &&
							((zp->index)-1<((m==0)?(l1):(l2))))
						  hr_bevelbox(zp->x1,zp->y1,zp->x2,zp->y2,
										  hr.def_colors,PRESSED);
					}
					ozp=zp;
				}
				/* Scrolling, selecting.*/
				if(zp!=NULL) {				
					/* Scrolling */
					switch(zp->index) {
					 case SCROLL_UP:
						if(yl>0)
						  --yl;				 
						break;
					 case SCROLL_DOWN:
						if(yl<(((m==0)?(l1):(l2))-MAX_ITEMS_ON_SCREEN-1))
						  ++yl;
						break;
					}
				}
				/* Keyboard controls */
				switch(hr_keyboard.lastkey){
				 case 27:
					if(ask_confirmation("Abort game?")){
						game_flags |= GAME_ABORTED;
						selection_made=1;
					}
					break;
				}			
				
			}
		}
		/* Don't check blahblah if the game was aborted.*/
		if(!(game_flags & GAME_ABORTED)){
			/* Do not allow aborting when the player has ran out of active
			 * weapons! */
			wl=p->weapons;
			while((wl->type)!=(p->active_weapon))
			  wl=wl->next;
			if((wl->amount)==0)
			  selection_made=0;
		}
	}
	hr_input_handler(NULL,NULL,AMB_RELEASED);
	free(ownedw);
	free(owneds);
	hr_delete_all_buttons();
	hr_delete_all_zones();
	/**/
	restore_game_screen();
	create_control_panel();
	update_control_panel(p,(PANEL_POWER|PANEL_ANGLE|
									PANEL_WEAPON|PANEL_SHIELD|PANEL_BARS));
}


/* Cycles through weapons/shields with non-zero default_amount.
 * If all default_amounts are 0, this will loop forever.*/
void change_default_item(int rosterindex,int m){
	struct weapon *w;
	struct shield *s;
	switch(m){
	 case 0:
		/* Change to next weapon */
		w=get_weapon(roster[rosterindex].default_weapon);
		do{
			w=w->next;
			if(w==NULL)
			  w=firstweapon;
		}while(w->default_amount==0);
		roster[rosterindex].default_weapon=(w->index);
		break;
	 case 1:
		/* Change to next shield */
		s=get_shield(roster[rosterindex].default_shield);
		do{
			s=s->next;
			if(s==NULL)
			  s=firstshield;
		}while(s->default_amount==0);
		roster[rosterindex].default_shield=(s->index);
		break;
	}
}
