/*
 *	Tykkipeli 2
 *	Control panel stuff.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <game_screen.h>
#include <players.h>
#include <weapons.h>
#include <shields.h>
#include <guns.h>
#include <change_item.h>
#include <info_windows.h>
#include <terrain.h>
#include <control_panel_defines.h>
#include <shield_defines.h>

#include <hr_bitmaps.h>
#include <hr_buttons.h>
#include <hr_mouse.h>
#include <hr_bobs.h>
#include <hr_zones.h>
#include <hr_fonts.h>
#include <hr_defines.h>
#include <hr_general.h>
#include <hr_input_handler.h>
#include <hr_keyboard.h>


/* Modifies player p's angle by amount degrees.*/
void add_angle(struct player *p,int amount) {
	(p->angle)+=amount;
	if((p->angle)<0)
	  (p->angle)=0;
	if((p->angle)>180)
	  (p->angle)=180;
}


/* Modifies player p's power.*/
void add_power(struct player *p,int amount) {
	(p->power)+=amount;
	if((p->power)<MIN_POWER)
	  (p->power)=MIN_POWER;
	if((p->power)>MAX_POWER)
	  (p->power)=MAX_POWER;
}


/* Updates ALL panel bars. Temporarily changes clippingwindow.*/
void panel_bars() {
	int z,l,h;
	int cx1,cy1,cx2,cy2;
	struct player *p;
	struct shield_list *sl;
	/* Damage bars */
#define BARW (S_WIDTH-524)
	/* Calc the amount of players for calcing h...*/
	z=0;p=firstplayer;
	while(p!=NULL){
		p=p->next;
		++z;
	}
	h=62/z;
	cx1=__clipx1;
	cy1=__clipy1;
	cx2=__clipx2;
	cy2=__clipy2;
	gl_setclippingwindow(522,PANEL_Y+16,MAX_X-1,S_HEIGHT-2);
	gl_fillbox(522,PANEL_Y+15,BARW,64,0);
	l=0;
	p=firstplayer;
	while(p!=NULL) {
		/* Damage bar */
		if((p->damage)>0)
		  gl_fillbox(522,(PANEL_Y+16)+l*h,
						 ((p->damage)*BARW)/MAX_DAMAGE,
						 h/2-1,p->britecolor);
		/* Shield bar */
		if((p->active_shield->index)!=CHARS2INT("None")){
			sl=p->shields;
			while((sl->type)!=(p->active_shield))
			  sl=sl->next;
			if((sl->amount)>0)
			  gl_fillbox(522,(PANEL_Y+16)+l*h+h/2,
							 ((sl->amount)*BARW)/(sl->type->efficiency),
							 h/2-1,p->darkcolor);
		}
		++l;
		p=p->next;
	}
	gl_setclippingwindow(cx1,cy1,cx2,cy2);
}


/* Creates the control panel. The control panel area is ALWAYS
 * 80 pixels tall. */
void create_control_panel() {
	int hotkey;
	struct hr_button *b;
	hr_delete_all_buttons();
	hr_delete_all_zones();
	gl_setclippingwindow(0,0,MAX_X,S_HEIGHT-1);
	
	hr_set_zone(1,0,0,MAX_X,MAX_Y);        /* Game area */
	
	/* First build the borders -------------------------------------*/
	/* Windmeter border */
	hr_bevelbox(S_WIDTH-WINDMETER_WIDTH,PANEL_Y+1,MAX_X,PANEL_Y+12,
					hr.def_colors,PRESSED);
	/* Player info */
	hr_bevelbox(0,PANEL_Y+14,158,PANEL_Y+48,hr.def_colors,PRESSED);
   hr_monowrite(2,PANEL_Y+37,1,0,"$",hr.font8x8,NONE);
	hr_monowrite(73,PANEL_Y+37,1,0,"Ratio",hr.font8x8,NONE);
	
	/* Bottomleft bevelboxes */
	hr_bevelbox(0,PANEL_Y+50,69,S_HEIGHT-1,hr.def_colors,PRESSED);
	hr_create_button(100,2,PANEL_Y+52,67,PANEL_Y+63,
						  hr.font8x8,hr.def_colors,
						  "Colors",NULL,ENABLED|NO_TAB_CYCLE);
	hr_create_button(101,2,PANEL_Y+65,67,S_HEIGHT-3,
						  hr.font8x8,hr.def_colors,
						  "Settings",NULL,NO_TAB_CYCLE);
	hr_bevelbox(71,PANEL_Y+50,158,S_HEIGHT-1,hr.def_colors,PRESSED);
	/* Turn and round.*/
	hr_monowrite(73,PANEL_Y+54,1,0,"Turn",hr.font8x8,NONE);
	hr_monowrite(73,PANEL_Y+66,1,0,"Round",hr.font8x8,NONE);
	/* Main control area*/
	hr_bevelbox(160,PANEL_Y+14,519,S_HEIGHT-1,hr.def_colors,PRESSED);
	hr_monowrite(165,PANEL_Y+19,1,0,"Angle",hr.font8x8,NONE);
   hr_monowrite(165,PANEL_Y+35,1,0,"Power",hr.font8x8,NONE);
   hr_monowrite(165,PANEL_Y+51,1,0,"Weapon",hr.font8x8,NONE);
   hr_monowrite(165,PANEL_Y+66,1,0,"Shield",hr.font8x8,NONE);
	/* Underlines.*/
   hr_monowrite(165,PANEL_Y+52,1,0,"_",hr.font8x8,NONE);
   hr_monowrite(165,PANEL_Y+67,1,0,"_",hr.font8x8,NONE);
	/* The rest is for damage/shield bars */
	hr_bevelbox(521,PANEL_Y+14,MAX_X,S_HEIGHT-1,hr.def_colors,PRESSED);
	/* Then create the needed buttons ------------------------------*/
	strcpy(buffer," ");
	/* Weapon/shield*/
	b=hr_create_button(1,218,PANEL_Y+49,450,PANEL_Y+61,
							 hr.font8x8,hr.def_colors,
							 buffer,"Select new weapon",
							 ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE);
	hotkey='w';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
	b=hr_create_button(2,218,PANEL_Y+64,450,PANEL_Y+76,
							 hr.font8x8,hr.def_colors,
							 buffer,"Select new shield",
							 ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE);
	hotkey='s';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
	/* Angle */
	b=hr_create_button(3,218,PANEL_Y+16,231,PANEL_Y+29,
							 hr.font8x8,hr.def_colors,
							 "<",NULL,
							 ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY);
	hotkey='<';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
   hr_create_button(4,233,PANEL_Y+16,263,PANEL_Y+29,
						  hr.font8x8,hr.def_colors,
						  buffer,NULL,ENABLED|NO_TAB_CYCLE);
   b=hr_create_button(5,265,PANEL_Y+16,278,PANEL_Y+29,
							 hr.font8x8,hr.def_colors,
							 ">",NULL,
							 ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY);
	hotkey='>';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
	/* QuickAngle(tm)*/
	b=hr_create_button(50,280,PANEL_Y+16,451,PANEL_Y+29,
							 hr.font8x8,hr.def_colors,
							 NULL,NULL,HSLIDER|ENABLED|PRESSED|NO_TAB_CYCLE);
	b->extras=hr_create_slider(HSLIDER|SLIDER_XNEG|
										SLIDER_GET_XVALINT|SLIDER_SET_XVALINT,
										181,10,30,180,&(active_player->angle),
										0,0,0,0,NULL);
	/* Power */
	b=hr_create_button(6,218,PANEL_Y+32,231,PANEL_Y+45,
							 hr.font8x8,hr.def_colors,
							 "-",NULL,
							 ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY);
	hotkey='-';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
	hr_create_button(7,233,PANEL_Y+32,263,PANEL_Y+45,
						  hr.font8x8,hr.def_colors,
						  buffer,NULL,ENABLED|NO_TAB_CYCLE);
	b=hr_create_button(8,265,PANEL_Y+32,278,PANEL_Y+45,
							 hr.font8x8,hr.def_colors,
							 "+",NULL,
							 ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY);
	hotkey='+';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
	/* QuickPower(tm)*/
	b=hr_create_button(51,280,PANEL_Y+32,451,PANEL_Y+45,
							 hr.font8x8,hr.def_colors,
							 NULL,NULL,HSLIDER|ENABLED|PRESSED|NO_TAB_CYCLE);
	b->extras=hr_create_slider(HSLIDER|SLIDER_GET_XVALINT|SLIDER_SET_XVALINT,
										MAX_POWER-MIN_POWER+1,37,90,MIN_POWER,
										&(active_player->power),
										0,0,0,0,NULL);
	/* Fire */
	hr.default_button=b=hr_create_button(9,453,PANEL_Y+17,516,PANEL_Y+45,
													 hr.font8x8,hr.def_colors,
													 "Fire","Fire!",ENABLED);
	hotkey='f';
	hr_update_button(0,b,UPDATE_HOTKEY,&hotkey);
}


/* Updates the control panel buttons and meters. */
void update_control_panel(struct player *p,int flags)  {	
	struct weapon_list *wl;
	struct shield_list *sl;
	int xx=0,yy=0,bflags;

	if(flags & PANEL_NAME) {		
		/* Name */
		/*kludge*/
		temp_colors->color2=p->britecolor;
		hr_textbox(2,PANEL_Y+16,156,PANEL_Y+33,
					  hr.font8x8,temp_colors,
					  p->name,PRESSED|ENABLED);
		/* $$$$ */
		sprintf(buffer,"%d",p->wealth);
		hr_textbox(12,PANEL_Y+35,69,PANEL_Y+46,
					  hr.font8x8,hr.def_colors,
					  buffer,PRESSED|ENABLED);
		sprintf(buffer,"%d",magic_ratio(p->deaths,p->kills,p->suicides));
		hr_textbox(115,PANEL_Y+35,156,PANEL_Y+46,
					  hr.font8x8,hr.def_colors,
					  buffer,PRESSED|ENABLED);
		/* Round. This needs to be updated only once per round,
		 * so it's located here :-) */
		sprintf(buffer,"%d/%d",round+1,round_n);
		hr_textbox(115,PANEL_Y+65,156,PANEL_Y+76,
					  hr.font8x8,hr.def_colors,
					  buffer,PRESSED|ENABLED);
	}

	if(flags & PANEL_WIND) {
		int w;
		/* Clear windmeter */
		gl_fillbox(S_WIDTH-WINDMETER_WIDTH+1,PANEL_Y+2,
					  WINDMETER_WIDTH-2,10,0);
		if(windmode>0) {
			/* Bar */
			w=MAX(1,((abs(wind)*(WINDMETER_WIDTH-2))/(MAX_WIND*windmode)/2));
			gl_fillbox(MAX_X-WINDMETER_WIDTH/2-((wind<0)?(w):(0)),
						  PANEL_Y+3,w,7,1);
		}
		/* Blue middle line */
		gl_line(MAX_X-WINDMETER_WIDTH/2,PANEL_Y+2,
				  MAX_X-WINDMETER_WIDTH/2,PANEL_Y+11,3);
	}
	
	if(flags & PANEL_TURN) {
		/* Turn */
		sprintf(buffer,"%d",turn);
		hr_textbox(115,PANEL_Y+52,156,PANEL_Y+63,
					  hr.font8x8,hr.def_colors,buffer,PRESSED|ENABLED);
		/* Recolor-buttons. This is a good place to update them, since it
		 * only needs to be done once a turn.*/
		bflags=ENABLED|NO_TAB_CYCLE;
		hr_update_button(100,NULL,UPDATE_FLAGS,&bflags);
		bflags=NO_TAB_CYCLE;
		hr_update_button(101,NULL,UPDATE_FLAGS,&bflags);
	}

	if(flags & PANEL_ANGLE) {
		/* QuickoAngle(tm)*/
		bflags=(ENABLED|PRESSED|HSLIDER|NO_TAB_CYCLE);
		hr_update_button(50,NULL,UPDATE_FLAGS,&bflags);
		/* Angle .*/
		/* Gun + AimAid(tm) */
		gl_setclippingwindow(0,0,MAX_X,MAX_Y);
		if(game_flags & AIM_AID) {
			xx=(p->x)+((pcos[p->angle]*BARREL_LEN*6)>>SCALE);
			yy=(p->y)-BARREL_OFFSET-((psin[p->angle]*BARREL_LEN*6)>>SCALE);
			hr_update_bob(crosshairs,0,0,NULL,BOB_REMOVE);
		}
		update_gun(p,BOB_SMART,NONE);
		if(game_flags & AIM_AID)
		  hr_update_bob(crosshairs,xx,yy,NULL,BOB_INIT);
		gl_setclippingwindow(0,0,MAX_X,S_HEIGHT-1);
		/* control panel stuff.*/
		bflags=(((p->angle)<180)?
				  (ENABLED):(NONE))|INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY;
		hr_update_button(3,NULL,UPDATE_FLAGS,&bflags);
		sprintf(buffer,"%d",p->angle);
		bflags=(((flags & PANEL_FREELY)?(PRESSED):(NONE))|ENABLED|NO_TAB_CYCLE);
		hr_update_button(4,NULL,UPDATE_FLAGS,&bflags);
		hr_update_button(4,NULL,UPDATE_TEXT,buffer);
		bflags=(((p->angle)>0)?
				  (ENABLED):(NONE))|INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY;
		hr_update_button(5,NULL,UPDATE_FLAGS,&bflags);
	}
	
	if(flags & PANEL_POWER) {
		/* QuickPower(tm)*/
		bflags=(ENABLED|PRESSED|HSLIDER|NO_TAB_CYCLE);
		hr_update_button(51,NULL,UPDATE_FLAGS,&bflags);
		/* Power . Buttons = 5,6,7*/
		bflags=((((p->power)>MIN_POWER)?(ENABLED):(NONE))
				  |INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY);
		hr_update_button(6,NULL,UPDATE_FLAGS,&bflags);
		sprintf(buffer,"%d",p->power);
		bflags=(((flags & PANEL_FREELY)?(PRESSED):(NONE))
				  |ENABLED|NO_TAB_CYCLE);
		hr_update_button(7,NULL,UPDATE_FLAGS,&bflags);
		hr_update_button(7,NULL,UPDATE_TEXT,buffer);
		bflags=((((p->power)<MAX_POWER)?(ENABLED):(NONE))
				  |INVISIBLE_HOTKEY|NO_TAB_CYCLE|NO_DELAY);
		hr_update_button(8,NULL,UPDATE_FLAGS,&bflags);
	}
	
	if(flags & PANEL_FIRE) {		
		/* FIRE! Button 8 */
		bflags=ENABLED;
		hr_update_button(9,NULL,UPDATE_FLAGS,&bflags);
	}
	
	if(flags & PANEL_WEAPON) {
		/* Active Weapon - Button 0 */
		bflags=(ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE);
		hr_update_button(1,NULL,UPDATE_FLAGS,&bflags);
		hr_update_button(1,NULL,UPDATE_TEXT,p->active_weapon->name);
		if(p->active_weapon->default_amount<0)			
		  sprintf(buffer,"Inf.");
		else{
			wl=p->weapons;
			while((wl->type)!=(p->active_weapon))
			  wl=wl->next;
			sprintf(buffer,"%d",wl->amount);
		}
		hr_textbox(452,PANEL_Y+49,517,PANEL_Y+61,
					  hr.font8x8,hr.def_colors,buffer,PRESSED|ENABLED);
	}
	
	if(flags & PANEL_SHIELD) {		
		/* Active Shield - Button 1 */
		bflags=(ENABLED|INVISIBLE_HOTKEY|NO_TAB_CYCLE);
		hr_update_button(2,NULL,UPDATE_FLAGS,&bflags);
		hr_update_button(2,NULL,UPDATE_TEXT,p->active_shield->name);
		if((p->active_shield->index)==CHARS2INT("None"))
		  sprintf(buffer,"-");
		else{
			sl=p->shields;
			while((sl->type)!=(p->active_shield))
			  sl=sl->next;
			sprintf(buffer,"%d%%",
					  ((sl->amount)*100)/(sl->type->efficiency));
		}
		hr_textbox(452,PANEL_Y+64,517,PANEL_Y+76,
					  hr.font8x8,hr.def_colors,buffer,PRESSED|ENABLED);
	}
	
	if(flags & PANEL_BARS)
	  panel_bars();
}


/* Prints a message to the control panel message area.
 * Temporarily changes clipping window.*/
void message(int color,unsigned char *msg)   {
	int cx1,cy1,cx2,cy2;
	if(msg!=NULL) {
		cx1=__clipx1;
		cy1=__clipy1;
		cx2=__clipx2;
		cy2=__clipy2;
		gl_setclippingwindow(0,PANEL_Y+1,MAX_X-WINDMETER_WIDTH,PANEL_Y+12);
		temp_colors->color2=color;
		hr_textbox(0,PANEL_Y+1,MAX_X-WINDMETER_WIDTH,PANEL_Y+12,
					  hr.font8x8,temp_colors,msg,PRESSED|ENABLED);
		gl_setclippingwindow(cx1,cy1,cx2,cy2);
	}
}


/* These funcs are for updating angle/power settings while dragging
 * sliders. Hmmm.*/
int change_angle(){
	hr_update_mouse(NONE,BOB_REMOVE);
	update_control_panel(active_player,PANEL_ANGLE|PANEL_FREELY);
	hr_update_mouse(NONE,BOB_INIT);
	return 0;
}
int change_power(){
	hr_update_mouse(NONE,BOB_REMOVE);
	update_control_panel(active_player,PANEL_POWER|PANEL_FREELY);
	hr_update_mouse(NONE,BOB_INIT);
	return 0;
}


/* Control handler ------------------------------------------*/
void control_handler(struct player *p) {
	int fire=0,x=0,ox,oy,bflags;
	struct hr_button *b;
	struct hr_zone *z;
	int (*func)();
	
	create_control_panel();
	update_control_panel(p,PANEL_NAME|PANEL_WIND|PANEL_TURN|PANEL_FIRE|
								PANEL_ANGLE|PANEL_POWER|PANEL_SHIELD|PANEL_WEAPON|
								PANEL_BARS);
	
	/* Random message.*/
	message(p->darkcolor,*(oneliners+random()%oneliner_n));
	
	/* AimAid(tm) bob sometimes overlaps with message area or windometer.
	 * --> potential gfx bug if message() is used.*/
	
	hr_clearkey();
	/* Loop until the dude FIREs! */
	hr_input_handler(NULL,NULL,AMB_RELEASED);
	while(!fire && !(game_flags & GAME_ABORTED)) {
		b=hr_input_handler(NULL,NULL,KBD_PRESSED|AMB_PRESSED);
		z=hr_get_zone(hr_mouse.x,hr_mouse.y,0);
		
		/* Was a key pressed? */
		switch(hr_keyboard.lastkey){
		 case 27:
			/* Escape - Abort game! */
			if(ask_confirmation("Abort game?"))
			  game_flags |= GAME_ABORTED;
			break;
		}
		
		/* Check if mouse pointer is positioned on game area */
		if(z!=NULL){
			if((z->index)==1) {			
				/* Aiming "intelligently"... */
				if(HR_LMB) {
					x=NONE;
					while(HR_LMB) {
						/* Mouse pointer must be above the gun.
						 * No gun can use angles <0 or >180. */
						hr_update_mouse(x,BOB_REMOVE);
						x=WAIT_EVENT;
						if(hr_mouse.y<(p->y)) {
							if((p->x)!=hr_mouse.x) {
								p->angle=(int)((atan((double)((p->y)-hr_mouse.y)/
															(double)(hr_mouse.x-(p->x)))
													 *360.0)/(2.0*M_PI));
								p->angle=abs(p->angle);
								/* Ugly.. FIX !!!!!!!!!!!!!!!!!!!!*/
								if(hr_mouse.x<(p->x))
								  p->angle=(180-(p->angle));
							}
							else
							  p->angle=90;
							update_control_panel(p,PANEL_ANGLE|PANEL_FREELY);
						}
						hr_update_mouse(NONE,BOB_INIT);
					}
					update_control_panel(p,PANEL_ANGLE);
				}
				/* Opens an info window */
				if(HR_RMB)
				  info_window(hr_mouse.x,hr_mouse.y);
			}
		}
		
		/* Set func point to null... */
		func=NULL;
		/* Buttons that respond immediately.*/
		if(b!=NULL) {
			switch(b->index)  {
			 case 3:
				/* Inc angle*/
				add_angle(p,1+((HR_RMB)?(4):(0)));
				update_control_panel(p,PANEL_ANGLE);
				break;
			 case 4:
				/* Change angle freely */
				ox=hr_mouse.x;
				oy=hr_mouse.y;
				update_control_panel(p,PANEL_ANGLE|PANEL_FREELY);
				while((HR_LMB)|(HR_RMB)) {
					x=hr_mouse.x;
					hr_update_mouse(WAIT_EVENT,BOB_NOIMG);
					if(x!=hr_mouse.x) {
						add_angle(p,x-hr_mouse.x);
						update_control_panel(p,PANEL_ANGLE|PANEL_FREELY);
					}
				}	
				mouse_setposition(ox,oy);
				break;
			 case 5:
				/* Dec angle */
				add_angle(p,-1-((HR_RMB)?(4):(0)));
				update_control_panel(p,PANEL_ANGLE);
				break;
			 case 6:
				/* Dec power */
				add_power(p,-1-((HR_RMB)?(4):(0)));
				update_control_panel(p,PANEL_POWER);
				break;
			 case 7:
				/* Change power freely */
				ox=hr_mouse.x;
				oy=hr_mouse.y;
				update_control_panel(p,PANEL_POWER|PANEL_FREELY);
				while((HR_LMB)||(HR_RMB))  {
					x=hr_mouse.x;
					hr_update_mouse(WAIT_EVENT,BOB_NOIMG);
					if(x!=hr_mouse.x)  {
						add_power(p,(hr_mouse.x-x)*2);
						update_control_panel(p,PANEL_POWER|PANEL_FREELY);
					}
				}
				mouse_setposition(ox,oy);
				break;
			 case 8:
				/* Inc power */
				add_power(p,1+((HR_RMB)?(4):(0)));
				update_control_panel(p,PANEL_POWER);
				break;
			 case 50:
				/* Set func */
				func=&change_angle;
				break;
			 case 51:
				/* Set func */
				func=&change_power;
				break;
			}
		}
		
		/* Wait until mouse keys are released.*/
		b=hr_input_handler(b,func,LMB_RELEASED|RMB_RELEASED);
		/* Buttons that respond after the mouse key is released.*/
		if(b!=NULL){
#ifndef KLUDGE_ASDADASDAS
			/* Make sure button is raised/shaded/etc properly */
			x=b->index;
			if((x>2) && (x<9))
			  update_control_panel(p,(x<6)?(PANEL_ANGLE):(PANEL_POWER));
			else{
				bflags=ENABLED|NO_TAB_CYCLE;
				hr_update_button(0,NULL,UPDATE_FLAGS,&bflags);
			}
#endif
			switch(b->index) {
			 case 1:
				change_active_item(p,0);
				break;
			 case 2:
				change_active_item(p,1);
				break;
			 case 9:
				/* FIRE. FIX? */
				fire=1;
				break;
			 case 50:
				/* QuickAngle(tm) */
				update_control_panel(p,PANEL_ANGLE);
				break;
			 case 51:
				/* QuickPower(tm) */
				update_control_panel(p,PANEL_POWER);
				break;
			 case 100:
				control_colors();
				break;
#if 0
			 case 101:
				/* Settings */
				option_onoff(kuukkeliskuu);
				break;
#endif
			}
		}
	}
	gl_setclippingwindow(0,0,MAX_X,MAX_Y);
	if(game_flags & AIM_AID)
	  hr_update_bob(crosshairs,p->x,p->y-20,NULL,BOB_REMOVE);
	gl_setclippingwindow(0,0,MAX_X,S_WIDTH-1);
}
