/*
 *  Constants, flags etc. for Tykkipeli 2
 *  Nearly all #defines are collected here.
 */

/* Used for misc stuff.*/
#define BUFFER_SIZE 1024

/* Sound support.*/
#undef SOUND_SUPPORT

/* Since explosions are bullets with EXPLODING flag set...*/
#define INIT_EXPLOSION init_bullet

/* Amount of money lost if one kills himself */
#define SUICIDE_LOSS 10000

/* Amount of computer players */
/* Stupidity quantity of computer players */
#define DEF_DROIDS 0
#define MAX_DROIDS 5
#define DEF_DROID_SQ 3
#define MAX_DROID_SQ 10

/* Barrel length and offset from gun's base y.*/
#define BARREL_LEN    8
#define BARREL_OFFSET 2
/* MAKE SURE TEMPMAP COVERS ALL THE GFX SURROUNDING
 * A GUN THAT ARE CHANGED! TEMPMAP_RANGE SHOULD BE AT LEAST
 * (BARREL_LEN+BARREL_OFFSET+1) pixels.*/
#define TEMPMAP_RANGE 15

/* Power and angle of guns.*/
#define DEF_ANGLE 90
#define DEF_POWER 333
#define MIN_POWER 10
#define MAX_POWER 666

/* Gravity */
#define DEF_G     13
#define MAX_G     30

/* Wind. Odd value is preferred for WINDMETER_WIDTH.*/
#define DEF_WIND  0
#define MAX_WIND  20
#define DEF_WINDMODE 2
#define MAX_WINDMODE 3
#define WINDMETER_WIDTH 49

/* "Bumpiness" of terrain.*/
#define DEF_BUMPINESS 10
#define MAX_BUMPINESS 20

/* Rounds.*/
#define DEF_ROUNDS   3
#define MAX_ROUNDS   50

/*These MUST be multiples of 1000!*/
#define DEF_MONEY    10000
#define MAX_MONEY    50000
#define DEF_WMONEY   5000
#define MAX_WMONEY   20000
/*These MUST be multiples of 5!*/
#define DEF_INTEREST 10
#define MAX_INTEREST 50

/* "Damage" is the hit point value of guns.*/
#define DEF_DAMAGE   500
#define MAX_DAMAGE   500

/* Default edge mode.*/
#define DEF_EDGES    0

/* Speed modifier. The bigger the value, the slower the heavy bullets fly.*/
#define BULLET_WEIGHT_SDEC 5

/*Flags for players*/
/* #define ENABLED 1 <-- also defined in hr_defines.h */
#define ALIVE             1
#define DROID             4
#define TURN_DONE         8
#define UPDATE_ASAP       16

/* Game flags */
#define TRACERS           2
#define PARTICLES         4
#define SOUNDEFFECTS      8
#define ROSTER_SAVED      16
#define DISASTERS         32
#define INFO_MODE         64
#define ACCIDENTAL_FIRE   128
#define SUICIDE_PENALTY   256
#define AIM_AID           512
#define GAME_SCREEN_SAVED 1024
#define ALIEN_TERRAIN     2048
#define ALIEN_SKY         4096
#define RANDOM_ORDER      8192
#define QUIET             16384
#define GAME_ABORTED      (1<<15)
#define GROUNDSMOOTHING   (1<<16)
#define TERRAIN_PIXMAPS   (1<<17)
#define SKY_PIXMAPS       (1<<18)
#define EXPLO_FLASH       (1<<19)
#define EXPLO_COLROT      (1<<20)
#define SHOPPING          (1<<21)
/* Game default flags. Sum together some of the values above, */
#define DEF_GFLAGS        (4+16+256+512+4096+SHOPPING)

/* Bullet default flags */
#define DEF_BFLAGS 0
/* Player default flags */
#define DEF_PFLAGS 1

/* Data file names.*/
#define WEAPONDATA        "weapons.data"
#define SHIELDDATA        "shields.data"
#define SPECIALDATA       "specials.data"

#define SCROLLTEXT_FILE   "intro.scrolltext"
#define INSTRUCTIONS      "instructions"
#define ONELINERS         "oneliners"

#define LOGOFILE          "tp2_logo.ilbm"

#define FAME_IMAGE        "Hall_of_Fame.ilbm"

#define GUN_DEFINITIONS   "gun_definitions"
#define DROID_DEFINITIONS "gun_definitions"
#define CROSSHAIRS_BITMAP "crosshairs.ilbm"

#define SAMPLE_LIST       "sample_list"

/* Game screen edge modes */
#define EDGES_NORMAL 0
#define EDGES_WRAP   1
#define EDGES_BOUNCY 2
/* Always make sure (EDGES_RANDOM==MAX_EDGEMODE) :-) */
#define EDGES_RANDOM 3
#define MAX_EDGEMODE 3

/* Roster */
#define ROSTER_SIZE 34
#define ROSTERFILE "roster"

/* Game screen control... */
#define S_WIDTH   640
#define S_HEIGHT  480
#define MAX_X     639
#define MAX_Y     399
/* Fly above this, and you're on orbit.*/
#define ORBIT_Y -100

/* Y offset of first line of control panel.*/
#define PANEL_Y   400

/* Minimum range between highest mountain tops and top of screen.*/
#define TERRAIN_BORDER 40
/* Minimum distance between two guns, or a gun and left/right edge of screen.*/
#define MIN_DISTANCE 40

/* These are for pixel_type() */
#define PIX_QUERY     0
#define PIX_SKY       1
#define PIX_GROUND    2
#define PIX_BULLET    3
#define PIX_EXPLOSION 4
#define PIX_GUN       5
#define PIX_SHIELD    6

/* Screen grabbing hotkey ('@') */
#define GRAB_KEY  64
#define GRAB_FUNC grabzen

