/*
 *	Tykkipeli 2
 *
 * Main game screen related functions.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <players.h>
#include <control_panel.h>
#include <explode.h>

#include <hr_bobs.h>
#include <hr_mouse.h>
#include <hr_defines.h>
#include <hr_general.h>
#include <hr_screens.h>

#include <colors.h>

/* Sets up the game palette.*/
void set_game_palette() {
	int c;
	/* First the HobbiRewl default colors 0-15...*/
	hr_default_palette();	
	/* Explosions */
	for(c=0;c<(MAXCOL_EXPLOSION-MINCOL_EXPLOSION+1);c++){
		explosion_color[c].r=63;
		explosion_color[c].g=63-c*4;
		explosion_color[c].b=0;
		gl_setpalettecolor(MINCOL_EXPLOSION+c,
								 explosion_color[c].r,
								 explosion_color[c].g,
								 explosion_color[c].b);
	}
	/* Bullet colors */	
	gl_setpalettecolor(MINCOL_BULLET,15,15,15);/* Gray */
	gl_setpalettecolor(MINCOL_BULLET+1,63,63,63);/* White */
	gl_setpalettecolor(MINCOL_BULLET+2,63,63,0);/* Yellow */
  	gl_setpalettecolor(MINCOL_BULLET+3,33,0,23);/* Brown */
	gl_setpalettecolor(MINCOL_BULLET+5,18,63,34);/* Bright Green */
	gl_setpalettecolor(MINCOL_BULLET+6,50,15,63);/* Dark pink */
	gl_setpalettecolor(MINCOL_BULLET+7,63,60,0);/* Yellow */
	/* Shield colors */
	/* FIX! Add the rest.*/
	gl_setpalettecolor(MINCOL_SHIELD,63,63,63); /* ShieldFlash (white) */
	/* Barrels */
	gl_setpalettecolor(MINCOL_BARREL,30,30,30);
}

/* Saves the game screen into a huge array */
void save_game_screen() {	
	hr_update_mouse(NONE,BOB_REMOVE);
	/* Yikes! This hurts! */
	game_screen=malloc(S_WIDTH*S_HEIGHT);
	/* Room for 3*256 bytes */
	game_palette=malloc(768);
	gl_getbox(0,0,S_WIDTH,S_HEIGHT,game_screen);
	gl_getpalette(game_palette);
	game_flags |= GAME_SCREEN_SAVED;
}

/* Totally rebuilds the game screen */
void restore_game_screen() {
	if(game_flags & GAME_SCREEN_SAVED) {
		hr_screen_open(G640x480x256,NONE);
		gl_setpalette(game_palette);
		free(game_palette);
		gl_putbox(0,0,S_WIDTH,S_HEIGHT,game_screen);
		free(game_screen);
		/* Mouse is re-inited in hr_input_handler */
		game_flags &= ~(GAME_SCREEN_SAVED);
	}
}
