/*
 *	Tykkipeli 2
 *	Gunzen...
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <game_screen.h>
#include <weapons.h>
#include <bullets.h>
#include <players.h>
#include <terrain.h>
#include <shields.h>
#include <colors.h>
#include <weapon_defines.h>
#include <shield_defines.h>

#include <hr_bobs.h>
#include <hr_defines.h>
#include <hr_bitmaps.h>
#include <hr_general.h>


/* Generic bob funcs not used... FIX!!!11111111111!!!! */
void update_gun(struct player *p,int pmode,int flags) {
	switch(pmode) {
	 case BOB_INIT:
		/* Initalization mode after the whole screen is changed.*/
		if(!(p->flags & BOB_INITIALIZED)){			 			 
			p->flags |= BOB_INITIALIZED;
			gl_getbox((p->x)-TEMPMAP_RANGE,(p->y)-TEMPMAP_RANGE,
						 (p->tempmap->width),(p->tempmap->height),
						 (p->tempmap->data));
			draw_addon(p,DRAW_SHIELD);
			draw_addon(p,DRAW_BARREL);
			/* This if() is necessary to make sure everything goes ok
			 * even if bitmap and deadmap have different dimensions.*/
			if(p->flags & ALIVE)
			  gl_putboxmask((p->x)-(p->bitmap->width)/2,
								 (p->y)-(p->bitmap->height)+1,
								 (p->bitmap->width),
								 (p->bitmap->height),
								 (p->bitmap->data));
			else
			  gl_putboxmask((p->x)-(p->deadmap->width)/2,
								 (p->y)-(p->deadmap->height)+1,
								 (p->deadmap->width),
								 (p->deadmap->height),
								 (p->deadmap->data));
		}
		break;
	 case BOB_SMART:
		/* Normal mode. Gun redrawn in the same place.*/
		if(p->flags & BOB_INITIALIZED){			 			 
			gl_putbox((p->x)-TEMPMAP_RANGE,(p->y)-TEMPMAP_RANGE,
						 (p->tempmap->width),(p->tempmap->height),
						 (p->tempmap->data));
			draw_addon(p,DRAW_SHIELD);
			draw_addon(p,DRAW_BARREL);
			if(p->flags & ALIVE)
			  gl_putboxmask((p->x)-(p->bitmap->width)/2,
								 (p->y)-(p->bitmap->height)+1,
								 (p->bitmap->width),(p->bitmap->height),
								 (p->bitmap->data));
			else
			  gl_putboxmask((p->x)-(p->deadmap->width)/2,
								 (p->y)-(p->deadmap->height)+1,
								 (p->deadmap->width),(p->deadmap->height),
								 (p->deadmap->data));
		}
		break;
	 case BOB_DUMB:
		draw_addon(p,DRAW_SHIELD);
		draw_addon(p,DRAW_BARREL);
		if(p->flags & ALIVE)
		  gl_putboxmask((p->x)-(p->bitmap->width)/2,
							 (p->y)-(p->bitmap->height)+1,
							 (p->bitmap->width),(p->bitmap->height),
							 (p->bitmap->data));
		else
		  gl_putboxmask((p->x)-(p->deadmap->width)/2,
							 (p->y)-(p->deadmap->height)+1,
							 (p->deadmap->width),(p->deadmap->height),
							 (p->deadmap->data));
		break;
	 case BOB_REMOVE:
		/* Remove the gun from screen */
		if(p->flags & BOB_INITIALIZED){
			gl_putbox((p->x)-TEMPMAP_RANGE,(p->y)-TEMPMAP_RANGE,
						 (p->tempmap->width),(p->tempmap->height),
						 (p->tempmap->data));
			p->flags &= ~(BOB_INITIALIZED);
		}
		break;
	}
}


/* Update all gun images */
void update_guns(int pmode,int flags) {
	struct player *p=firstplayer;
	while(p!=NULL) {		
		update_gun(p,pmode,flags);
		p=p->next;
	}
}


/* Select random places for guns, and glide them down to earth */
void init_guns() {
	int x,xx,x1,x2,y;
	struct player *p;
	char marked[S_WIDTH];
	for(xx=0;xx<=MAX_X;xx++)
	  marked[xx]=0;
	/* Randomize locationzen! */
	p=firstplayer;
	while(p!=NULL) {
		do{
			x=1+MIN_DISTANCE+random()%(S_WIDTH-2-2*MIN_DISTANCE);
			x1=x-MIN_DISTANCE;
			x2=x+MIN_DISTANCE;
		}while(marked[x]);
		for(xx=x1;xx<=x2;xx++)
		  marked[xx]=1;
		/* Beam them down :-)*/
		y=0;
		while(!(pixel_type(PIX_GROUND,vga_getpixel(x,y+1)))){
			y++;
			if((y%20)==0)
			  vga_waitretrace();
			gl_setpalettecolor(MINCOL_FREE,random()%64,random()%64,0);
			gl_hline(x-2-(p->bitmap->width)/2,y,
						x+2+(p->bitmap->width)/2,MINCOL_FREE);
		}
		/* Draw sky... recalc local height.*/
		calc_heights(x-2-(p->bitmap->width)/2,x+2+(p->bitmap->width)/2);
		for(y=x-2-(p->bitmap->width)/2;y<=x+2+(p->bitmap->width)/2;y++)
		  sky_column(y);
		/* Put gun to its place.*/
		p->x=x;
		p->y=terrain[x]-1;
		/* Init gun (BOB_REMOVEd in post_round_stuff) */
		update_gun(p,BOB_INIT,NONE);
		p=p->next;
	}
}


/* Moves a gun to coordinates x,y.
 * Returns 1 if succesful, 0 otherwise. */
void move_gun_to(struct player *p,int x,int y){
	update_gun(p,BOB_REMOVE,NONE);
	p->x=x;
	p->y=y;
#ifndef SLOW_KLUDGES_RULE
	/* This kludge removes particles and bullets from the NEW
	 * position on screen. This way the tempmap does not get
	 * cluttered with crap :-) Much faster to
	 * do this than add checks and gun-inits/restoration
	 * to fly_bullets().*/
	replace_with_sky((p->x)-TEMPMAP_RANGE,(p->y)-TEMPMAP_RANGE,
						  (p->x)+TEMPMAP_RANGE,(p->y)+TEMPMAP_RANGE,
						  MINCOL_BULLET,MAXCOL_BULLET);
#endif
	update_gun(p,BOB_INIT,NONE);
}


/* Moves a gun to some direction. */
void move_gun(struct player *p,int xdelta,int ydelta){
	move_gun_to(p,(p->x)+xdelta,(p->y)+ydelta);
}


/* Drops the guns after a collapse...
 * Falling hurtzzz... returns 1 if a gun was dropped.
 * Note that this only checks/drops every gun ONCE,
 * then exits.
 * Does nothing in zero gravity.*/
int drop_guns() {
	int x,dropped_some=0,drop,w2;
	struct player *p;
	if(g>0){
		p=firstplayer;
		while(p!=NULL) {
			/* If the gun is already at lowest possible y coordinate,
			 * skip unnecessary checks.*/
			if((p->y)>=MAX_Y)
			  drop=0;
			else
			  drop=1;
			/* gunmap and deadmap can have different widths...*/
			w2=((p->flags & ALIVE)?
				 (p->bitmap->width):(p->deadmap->width))/2;
			/**/
			for(x=(p->x)-w2;x<=(p->x)+w2;x++){
				if(pixel_type(PIX_GROUND,
								  vga_getpixel(x,(p->y)+1))){
					
					drop=0;
					break;
				}
			}
			/* Drop if necessary */
			if(drop) {
				/* Set return value.*/
				dropped_some=1;
				/* Drop the gun and give it some damage, but only
				 * every 6th frame. */
				/* Hurt it.*/
				if(gfx_counter%2)
				  hurt(p,NULL,1,DAMAGE_DROP);
				if((gfx_counter%6)==5)
				  move_gun(p,0,1);
			}
			p=p->next;
		}
	}
	return dropped_some;
}


/* Returns 0, or pointer to player under coordinates x,y. */
struct player *is_gun(int x,int y)  {	
	struct player *p,*tp;
	int xd;
	if((x<0)||(y<0)||(x>MAX_X)||(y>MAX_Y))
	  return NULL;
	/* Color range check. */
   if(pixel_type(PIX_GUN,vga_getpixel(x,y))){
		/* Now we know it hit SOME gun.
		 * The gun with shortest x distance to point (x,y) is the
		 * most probable "owner" gun of this pixel. Not 100% reliable.. :-( */
		p=firstplayer;
		tp=NULL;
		xd=S_WIDTH;
		while(p!=NULL) {		
			if(abs(x-(p->x))<xd) {
				xd=abs(x-(p->x));
				tp=p;
			}
			p=p->next;
		}
		if(tp!=NULL)
		  return tp;
	}
	else {
		/* This check will always work, but is badly brain damaged
		 * - for example, collisions with gun barrels are not noticed.*/
		p=firstplayer;
		while(p!=NULL) {		
			if((y<=(p->y)) &&
				(y>(p->y)-((p->flags & ALIVE)?
							  (p->bitmap->height):(p->deadmap->height)))&&
				(abs(x-(p->x))<=((p->flags & ALIVE)?
									  (p->bitmap->width):(p->deadmap->width))/2))
			  {
				  return p;
			  }
			p=p->next;
		}
	}
	/* Ok, then.*/
	return NULL;
}


/* Removes / inits all guns on xrange [x1,x2].*/
void update_guns_on_xrange(int x1,int x2,int mode,int flags){
	struct player *p;
	int xmid,xrng;
	x1=MAX(x1,0);
	x2=MIN(MAX_X,x2);
	if(x1<=x2){
		xmid=(x1+x2)/2;
		/* FIX xrng! */
		xrng=TEMPMAP_RANGE+((x2-x1)/2)+1;
		/**/
		/* Faster to check all players than check all pixels on xrange.
		 * The guns may overlap.*/
		p=firstplayer;
		while(p!=NULL){
			if( abs((p->x)-xmid)<xrng )
			  update_gun(p,mode,flags);
			p=p->next;
		}
	}
}

