/*
 *	Tykkipeli 2 Hall of Fame
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <game_screen.h>
#include <players.h>
#include <info_windows.h>

#include <hr_mouse.h>
#include <hr_bobs.h>
#include <hr_fonts.h>
#include <hr_defines.h>
#include <hr_general.h>
#include <hr_input_handler.h>
#include <hr_bitmaps.h>
#include <hr_ilbm.h>
#include <hr_keyboard.h>
#include <hr_screens.h>

#define DO_NOT_FLIP
#define NAMES_ON_SCREEN 15
#define NAME_OFFSET 20
#define DATA_OFFSET 220
#define DATA_CHANGE_TIME 50
#define STAR_N 100

void hall_of_fame(){
	int a=0,ax=0,ay=90,x0,y0,x1,y1,w,h,w2,h2,xx,yy,r,c;
	int sortednames=0,back_to_option_screen=0;
	int xcounter=0,ycounter=0,xd,yd,data_counter=0,color_counter=0;
	int skip_the_rest=0;
	int star_x[STAR_N],star_y[STAR_N],star_ys[STAR_N];
	int xz=100,yz=100;
	struct hr_bitmap *rotmap;
	int ri[ROSTER_SIZE];
	
	/* Zero the global gfx counter */
	gfx_counter=0;
	
	/* Create ri[] table with roster indexes.*/
	for(r=0;r<ROSTER_SIZE;r++){
		if(roster[r].games>0)
		  ri[sortednames++]=r;
	}
	/* Sort the table. FIX! */
	/* Mark (Last to first).*/
	for(yy=sortednames-1;yy>0;yy--){
		/* First to mark-1.*/
		for(r=0;r<yy;r++){
			if(magic_ratio(roster[ri[r+1]].deaths,
								roster[ri[r+1]].kills,
								roster[ri[r+1]].suicides)
				>magic_ratio(roster[ri[r]].deaths,
								 roster[ri[r]].kills,
								 roster[ri[r]].suicides))
				{
					/*asdsd*/
					xx=ri[r+1];
					ri[r+1]=ri[r];
					ri[r]=xx;
				}
		}
	}
	/* Too many sorted names? Too bad...*/
	sortednames=MIN(NAMES_ON_SCREEN,sortednames);
		
	/* Open a buffered screen */
	hr_screen_open(G320x200x256,SCREEN_VIRTUAL);

	/* Create bitmap.*/
	sprintf(buffer,"%s/pixmaps/%s",tp2_datapath,FAME_IMAGE);
	rotmap=hr_read_ilbm(buffer,GFX_256COLOR);
	
	hr_recolor_bitmap(rotmap,191,NONE);
	hr_use_bitmap_palette(rotmap,192,255,NONE);
	hr_default_palette();
	gl_setpalettecolor(0,0,0,0);
	/* Colors for names */
	for(c=0;c<sortednames;c++)
	  gl_setpalettecolor(32+c,random()%64,random()%64,random()%64);
	
	w=rotmap->width;
	w2=w/2;
	h=rotmap->height;
	h2=h/2;
	
	/* Init stars */
	for(r=0;r<STAR_N;r++){
		star_x[r]=random()%320;
		star_y[r]=random()%200;
		star_ys[r]=-1-random()%5;		
	}
	/* The slower the star, the darker its color.*/
	for(r=0;r<5;r++)
	  gl_setpalettecolor(64+r,20+r*8,20+r*8,20+r*8);
	
	/* Colors for title/bottom texts.*/
	gl_setpalettecolor(16,63,63,63);
	gl_setpalettecolor(17,52,63,23);
	gl_setpalettecolor(18,63,0,0);
	
	hr_clearkey();
	hr_input_handler(NULL,NULL,AMB_RELEASED);
	hr_update_mouse(NONE,BOB_INIT);
	while(!(HR_LMB) &&
			!(HR_RMB) &&
			!(back_to_option_screen)) {
		/**/
		if(hr_getkey())
		  back_to_option_screen=1;
		/* Inc some counters */
		if(((++gfx_counter)%DATA_CHANGE_TIME)==0)
		  ++data_counter;
		color_counter+=11;
		if(++a>359)
		  a=0;
		if(++xcounter%2)
		  ++ycounter;
		if(++ax>719)
		  ax=0;
		if(++ay>1079)
		  ay=0;
		xd=xcounter%2;
		yd=ycounter%2;
		/* X/Y Zoom factors. */
		xz=300+((pcos[(gfx_counter/5)%360]*512)>>SCALE);
		yz=300+((psin[(gfx_counter/3)%360]*512)>>SCALE);

		/* Rotate picture. Only calc half the # of pixels.*/
		for(xx=xd;xx<320;xx+=2){
			/* Unrotated xLocation inside rotmap.*/
			x0=xx-160;
			/* xZoomed location inside rotmap. */
			x0=(x0*512)/xz;
			skip_the_rest=0;
			for(yy=100-yd;yy>=yd;yy-=2){
				/* If we have already passed printable pixels, do not
				 * even calc the rest.*/
				if(!skip_the_rest){
					/* Unrotated yLocation inside rotmap*/
					y0=yy-100;
					/* yZoomed location inside rotmap.*/
					y0=(y0*512)/yz;
					/* Rotated position inside rotmap */
					y1=(((y0*pcos[a]-x0*psin[a])>>SCALE)+h2);
					if((y1<=h) && (y1>0)){
						x1=(((x0*pcos[a]+y0*psin[a])>>SCALE)+w2);
						if((x1>=0)&&(x1<w)){
							/* Draw the pixel AND a mirrored pixel. */				
							gl_setpixel(xx,yy,
											*((rotmap->data)+y1*w+x1));
							gl_setpixel(319-xx,199-yy,
											*((rotmap->data)+(h-1-y1)*w+(w-1-x1)));
						}
						else
						  skip_the_rest=1;
					}
					else
					  skip_the_rest=1;
				}
				/* Draw black if (x1,y1) is outside original bitmap.*/
				if(skip_the_rest){
					gl_setpixel(xx,yy,0);
					gl_setpixel(319-xx,199-yy,0);					
				}
			}
		}

		/* Paragraph names.*/
		hr_monowrite(NAME_OFFSET,4,16,0,
						 "Name",
						 hr.font8x8,NONE);
		switch(data_counter%7){
		 case 0:
		 case 1:
			strcpy(buffer,"Magic ratio");
			break;
		 case 2:
			strcpy(buffer,"Deaths");
			break;
		 case 3:
			strcpy(buffer,"Kills");
			break;
		 case 4:
			strcpy(buffer,"Suicides");
			break;
		 case 5:
			strcpy(buffer,"Games played");
			break;
		 case 6:
			strcpy(buffer,"Games won");
			break;
		}
		hr_monowrite((DATA_OFFSET/2)+160-(strlen(buffer)*4),4,
						 16,0,buffer,hr.font8x8,NONE);
		
		/* asdsad */
		for(r=0;r<sortednames;r++){
			/* Print a truncated copy of player name.*/
			strcpy(buffer,roster[ri[r]].name);
			buffer[(DATA_OFFSET-8)/8]=0;
			hr_monowrite(NAME_OFFSET,22+r*11,32+r,0,
							 buffer,
							 hr.font8x8,NONE);
			/* Print other player info.*/
			switch(data_counter%7){
			 case 0:
			 case 1:
				sprintf(buffer,"%d",magic_ratio(roster[ri[r]].deaths,
														  roster[ri[r]].kills,
														  roster[ri[r]].suicides));
				break;
			 case 2:
				sprintf(buffer,"%d",roster[ri[r]].deaths);
				break;
			 case 3:
				sprintf(buffer,"%d",roster[ri[r]].kills);
				break;
			 case 4:
				sprintf(buffer,"%d",roster[ri[r]].suicides);
				break;
			 case 5:
				sprintf(buffer,"%d",roster[ri[r]].games);
				break;
			 case 6:
				sprintf(buffer,"%d",roster[ri[r]].won);
				break;
			}
			hr_monowrite((DATA_OFFSET/2)+160-(strlen(buffer)*4),
							 22+r*11,32+r,0,buffer,hr.font8x8,NONE);
			/* Modify name color. */
			gl_setpalettecolor(32+r,
									 32+((pcos[(color_counter+r*22)%360]*31)>>SCALE),
									 32+((psin[(color_counter+r*33)%360]*31)>>SCALE),
									 32+((pcos[(color_counter+r*44)%360]*31)>>SCALE));
		}
		/* Scrolling text on fire.. */
		hr_monowrite(330-(gfx_counter%510),190,18,0,
						 "Click mouse to continue",
						 hr.font8x8,NONE);
		hr_monowrite(329-(gfx_counter%510),190,17,0,
						 "Click mouse to continue",
						 hr.font8x8,NONE);
		
		/* Draw stars.*/
		for(r=0;r<STAR_N;r++){
			if(gl_getpixel(star_x[r],star_y[r])==(63-star_ys[r]))
			  gl_setpixel(star_x[r],star_y[r],0);
			star_y[r]+=star_ys[r];
			if(star_y[r]<0)
			  star_y[r]+=200;
			if(gl_getpixel(star_x[r],star_y[r])==0)
			  gl_setpixel(star_x[r],star_y[r],(63-star_ys[r]));
		}
				
		/* Draw mouse and update screen*/
		hr_update_mouse(NONE,BOB_DUMB);
		vga_waitretrace();
		gl_copyscreen(hr.physicalscreen);
	}
	hr_update_mouse(NONE,BOB_REMOVE);
	/* Free mem.*/
	hr_screen_close(hr.active_screen);
	hr_delete_bitmap(rotmap);
}
