/*
 *	Tykkipeli 2 intro screen
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <version.h>
#include <game_screen.h>
#include <players.h>
#include <info_windows.h>

#include <hr_mouse.h>
#include <hr_fonts.h>
#include <hr_bobs.h>
#include <hr_defines.h>
#include <hr_general.h>
#include <hr_keyboard.h>
#include <hr_screens.h>


/* Intro screen stuff */
#define STAR_N     300
#define STAR_LEN   10
#define STAR_SPEED 5
#define STAR_MINZ  20
#define STAR_MAXZ  (STAR_MINZ+STAR_N*STAR_SPEED)
/* */
#define VECTOR_N   94
#define LOGO_N     4
#define ROTSPEED1  2
#define ROTSPEED2  3
#define ZOOMSPEED  1
#define Z_OFFSET   3500000
/**/
#define BGR_COLOR  2

/* This is the _only_ palette that modifies color 0 */
void set_intro_palette(){
	int y=0;
	/* Default colors (only 0-7) */
	hr_default_palette();

	/* Colors 8-59 for vector logo */
	for(y=0 ;y<=8;y++)
	  gl_setpalettecolor(8+y,63,y*7,0);
	for(y=0;y<=2;y++)
	  gl_setpalettecolor(17+y,0,63-y*14,0);
	gl_setpalettecolor(20,10,30,63);
	gl_setpalettecolor(21,0,0,63);
	/* 60-63 texts */
	gl_setpalettecolor(60,10,10,10);
	gl_setpalettecolor(61,40,50,60);
	gl_setpalettecolor(62,20,40,20);
	gl_setpalettecolor(63,20,20,20);
	/* Colors 64-69 for borders */
	for(y=64;y<70;y++)
	  gl_setpalettecolor(y,0,0,(y-63)*10);
	/* Colors 128-191 Stars */
	for(y=0;y<=63;y++)
	  gl_setpalettecolor(128+y,63-y,63-y,63-y);
	/* Colors 192-255 for copperbars */
   for(y=0;y<63;y++)
	  gl_setpalettecolor(255-y,y+1,0,y+1);
}


/**/
int intro(){
	int x,y,i,l=0,l2,slenc,c=-1,logo_counter=0;
	int angle1=0,angle2=0,zdelta=0,keypress=0;
	FILE *fp;
	unsigned char *scrolltext=NULL;
	int scrolltextlen=0;
	/* Some temp variables */
	int tt,ps,pc;
	
	/* Init stars */
	struct {
		int x;
		int y;
		int z;
		int flags[STAR_LEN];
		int screen_x[STAR_LEN];
		int screen_y[STAR_LEN];
	} star[STAR_N];
	
	/* Screen coordinates for the vector logo.*/
	int screen_x[LOGO_N][VECTOR_N], screen_y[LOGO_N][VECTOR_N];

	/* This is a temp array for logo */
	struct {
		long x;
		long y;
		long z;
	} tline[VECTOR_N];

	/* Create the 3D vector logo */
	struct {
		int x;
		int y;
		int z;
		int target;
		int color;
	} line[VECTOR_N]= {
		/* T */
		  { -17, 2, 4, 2,8 },
		  { -14, 2, 4, 3,8 },
		  { -14, -2, 4,4 ,8 },
		  { -15, -2, 4, 5,8 },
		  { -15, 1, 4, 6,8 },
		  { -17, 1, 4, 1,8 },
		/* y */
		  { -13, 0, 3, 8,9 },
		  { -12, -1, 3, 9,9 },
		  { -12, 0, 3, 10,9 },
		  { -11, 0, 3, 11,9 },
		  { -11, -4,3 , 12,9 },
		  { -15, -4, 3, 13,9 },
		  { -15, -3, 3,14 ,9 },
		  { -12, -3, 3,15 ,9 },
		  { -12, -2, 3,16 ,9 },
		  { -13, -2, 3, 7,9 },
		/* k */
		  { -10,2 ,2 ,18 ,10 },
		  { -9, 2, 2, 19,10 },
		  { -9, 0, 2,20 ,10 },
		  { -8, 1, 2,21 ,10 },
		  { -7, 1, 2,22 ,10 },
		  { -8, 0,2 ,23 ,10 },
		  { -7, -2, 2,24 ,10 },
		  { -8,-2 , 2,25 ,10 },
		  { -9, -1, 2,26 ,10 },
		  { -9, -2, 2,27 ,10 },
		  { -10,-2, 2,17 ,10 },
		/* k */
		  { -6,2 ,1 ,29 ,11 },
		  { -5, 2, 1, 30,11},
		  { -5, 0, 1,31 ,11},
		  { -4, 1, 1,32 ,11},
		  { -3, 1, 1,33 ,11},
		  { -4, 0,1 ,34 ,11},
		  { -3, -2, 1,35 ,11 },
		  { -4,-2 , 1,36 ,11 },
		  { -5, -1, 1,37 ,11 },
		  { -5, -2, 1,38 ,11 },
		  { -6,-2, 1,28 ,11 },
		/* i */
		  { -2, 2, 0, 40,12 },
		  { -1, 2, 0, 41,12},
		  { -1, 1, 0, 42,12 },
		  { -2, 1, 0, 39,12 },

		  { -2, 0, 0, 44,12 },
		  { -1, 0, 0, 45,12 },
		  { -1, -2, 0, 46,12 },
		  { -2, -2, 0, 43,12 },
		/* P */
		  { 0, 3, -1, 48,13 },
		  { 3, 3, -1, 49,13 },
		  { 3, 0, -1, 50,13 },
		  { 1, 0, -1, 51,13 },
		  { 1, -2, -1, 52,13 },
		  { 0, -2, -1, 47,13 },

		  { 1, 2, -1, 54,13 },
		  { 2, 2, -1, 55,13 },
		  { 2, 1, -1, 56,13 },
		  { 1, 1, -1, 53,13 },
		/* e */
		  { 4, 1, -2, 58,14 },
		  { 6, 1, -2, 59,14 },
		  { 5, 0, -2, 60,14 },
		  { 6, 0, -2, 61,14 },
		  { 5, -1, -2, 62,14 },
		  { 6, -2, -2, 63,14 },
		  { 4, -2, -2, 57,14 },
		/* l */
		  { 7, 3, -3, 65,15 },
		  { 8, 3, -3, 66,15 },
		  { 8, -2,-3, 67,15 },
		  { 7, -2,-3, 64,15 },
		/* i */
		  { 9, 0, -4, 69,16 },
		  { 10, 0, -4, 70,16 },
		  { 10, -2, -4, 71,16 },
		  { 9, -2, -4, 68,16 },

		  { 9, 2, -4, 73,16 },
		  { 10, 2, -4, 74,16 },
		  { 10, 1, -4, 75,16 },
		  { 9, 1, -4, 72,16 },
		/* 2 */
		  { 12, 3, 0, 77,17 },
		  { 16, 3, 0, 78,18},
		  { 16, 0, 0, 79,18 },
		  { 13, 0, 0, 80,19 },
		  { 13, -1, 0, 81,19 },
		  { 17, -1, 0, 82,19 },
		  { 17, -2, 0, 83,19 },
		  { 12, -2, 0, 84,19 },
		  { 12, 1, 0, 85,18 },
		  { 15, 1, 0, 86,18 },
		  { 15, 2, 0, 87,17 },
		  { 12, 2, 0, 76,17 },
		/* Lightning */
		  { -18, -5, 4,89,20 },
		  {  7 , -4, 4,90,20 },
		  {  1 , -4, 0,91,20 },
		  {  16, -3, 3,92,21 },
		  {  16, -3,-3,93,21 },
		  { -6 , -4, -3,94,21 },
		  { -1 , -4, 1,88,21 }
	};		
	
	/* Read scrolltext */
	sprintf(buffer,"%s/text/%s",tp2_datapath,SCROLLTEXT_FILE);
	if((fp=fopen(buffer,"r"))){
		fseek(fp,0,SEEK_END);
		scrolltextlen=(int)ftell(fp);
		scrolltext=malloc(scrolltextlen+1);
		fseek(fp,0,0);
		fread(scrolltext,scrolltextlen,1,fp);
		fclose(fp);
		/* Convert linefeeds etc into spaces */
		for(i=0;i<scrolltextlen;i++){
			if(*(scrolltext+i)<32)
			  *(scrolltext+i)=32;
		}
		/* End-of-string */
		*(scrolltext+scrolltextlen)=0;
	}
	
	/* Init stars */
	for(i=0;i<STAR_N;i++) {
		star[i].x=(800-random()%1600)<<7;
		star[i].y=(800-random()%1600)<<7;
		star[i].z=2*STAR_MINZ+(i*STAR_MAXZ)/STAR_N;
		for(x=0;x<STAR_LEN;x++) {
			star[i].flags[x]=0;
			star[i].screen_x[x]=0;
			star[i].screen_y[x]=0;
		}
	}
	slenc=STAR_LEN-1;
	x=0;
	
	hr_screen_open(G640x480x256,NONE);
	set_intro_palette();
	gl_clearscreen(BGR_COLOR);

	/* All black lines are just plotted to (200,200) when the logo
	 * starts rotating. */
	for(i=0;i<VECTOR_N;i++){
		for(l2=0;l2<LOGO_N;l2++)
		  screen_x[l2][i]=screen_y[l2][i]=200;
	}
	
	/* Copperbars */
	for(y=0;y<63;y++) {
		gl_hline(0,y,639,192+y);
		gl_hline(0,479-y,639,192+y);
	}
	
	/* Borders */
	for(y=0;y<6;y++) {	
		gl_line(10-y,20-y,629+y,20-y,64+y);
		gl_line(629+y,20-y,629+y,469+y,64+y);
		gl_line(629+y,469+y,10-y,469+y,64+y);
		gl_line(10-y,469+y,10-y,20-y,64+y);
	}
	
	hr_monowrite(12,460,63,0,TP2_VERSION,hr.font8x8,NONE);
	HR_CENTER(320,4,60,0,"Programmed by K.Veijalainen",hr.font8x8,NONE);
	HR_CENTER(320,450,61,0,"Press Esc to quit, any other key to continue.",
				 hr.font8x8,NONE);

	hr_clearkey();
	
	/* Main intro loop.*/
	gfx_counter=0;
	while(gfx_counter<120) {
		/* */
		if(gfx_counter>0)
		  ++gfx_counter;
		else{
			if(HR_LMB)
			  /* Disable removing of star trails */
			  gfx_counter=1;
			/* Esc/q/Q pressed? */
			if(hr_getkey()){
				switch(hr_keyboard.lastkey){
				 case 27:
				 case 81:
				 case 113:
					if(ask_confirmation("Really quit?")){
						if(!(game_flags & ROSTER_SAVED)){
							if(ask_confirmation("Save roster?"))
							  save_roster();
						}
						keypress=1;
					}
					break;
				 default:
					keypress=2;
					break;
				}
				/* Get the hell out if any key was pressed.*/
				if(keypress>0)
				  break;
			}
		}
		
		angle1+=ROTSPEED1; if(angle1>359)angle1-=360;
		angle2+=ROTSPEED2; if(angle2>359)angle2-=360;				
		zdelta+=ZOOMSPEED; if(zdelta>359)zdelta-=360;
		
		
		/* LOGO */
		/* Modify tline[]-array. */
		ps=psin[angle2];
		pc=pcos[angle2];
		for(i=0;i<VECTOR_N;i++){
			/* Rotate around Y-axis */
			tline[i].x=line[i].x*pc + line[i].z*ps;
			tline[i].y=line[i].y<<SCALE;
			tline[i].z=(-line[i].x*ps+line[i].z*pc+(gfx_counter<<18));
		}
		
		/* logo_counter marks current position in screen_x/y[]-arrays.*/
		logo_counter=(++logo_counter)%LOGO_N;
		
		/* Calc new screen coordinates */
		ps=Z_OFFSET+(psin[zdelta]<<5);
		for(i=0;i<VECTOR_N;i++){
			screen_x[logo_counter][i]=
			  320+(tline[i].x<<8)/(ps+tline[i].z);
			screen_y[logo_counter][i]=
			  240-(tline[i].y<<8)/(ps+tline[i].z);
		}
		
		/* Remove old and draw new vectors */
		l2=(logo_counter+1)%LOGO_N;
		for(i=0;i<VECTOR_N;i++){
			/* Out with the old */
			gl_line(screen_x[l2][i],
					  screen_y[l2][i],
					  screen_x[l2][line[i].target-1],
					  screen_y[l2][line[i].target-1],BGR_COLOR);
			/* In with the new */
			gl_line(screen_x[logo_counter][i],
					  screen_y[logo_counter][i],
					  screen_x[logo_counter][line[i].target-1],
					  screen_y[logo_counter][line[i].target-1],
					  line[i].color);
		}


		/* STARS */
		/* Indexes blah blah */
		if((++slenc)>=STAR_LEN)
		  slenc=0;
		for(i=0;i<STAR_N;i++) {
			if(gfx_counter==0) {
				if(star[i].flags[slenc])
				  /* Remove old dot */
				  gl_setpixel(star[i].screen_x[slenc],
								  star[i].screen_y[slenc],BGR_COLOR);
			}
			star[i].flags[slenc]=0;
			/* Move star */
			star[i].z-=STAR_SPEED;
			/* Calc new screen coordinates */
			star[i].screen_x[slenc]=320+star[i].x/star[i].z;
			star[i].screen_y[slenc]=240+star[i].y/star[i].z;
			/* Draw star */
			if((star[i].screen_y[slenc]>64) &&
				(star[i].screen_y[slenc]<408)){
				if(((star[i].screen_x[slenc]>=10)&&
					 (star[i].screen_x[slenc]<=629))||
					((star[i].screen_x[slenc]>=0)&&
					 (star[i].screen_x[slenc]<5)) ||
					((star[i].screen_x[slenc]<=639)&&
					 (star[i].screen_x[slenc]>634)))
				  {
					  gl_setpixel(star[i].screen_x[slenc],star[i].screen_y[slenc],
									  128+(star[i].z*63)/STAR_MAXZ);
					  star[i].flags[slenc]=1;
				  }
			}
			if(star[i].z<=STAR_MINZ)
			  star[i].z=STAR_MAXZ;
		}
				
		vga_waitretrace();
		/* Update mouse structure data */
		hr_update_mouse(NONE,BOB_NOIMG);
		
		/* Scrolltext */
		gl_copybox(13,408,616,8,12,408);
		if(!(tt=(l++)%8)){
			if((++c)>=scrolltextlen)
			  c=0;
		}
		hr_partial_monowrite(627,408,62,0,*(scrolltext+c),tt,0,tt,7,
									hr.font8x8,NONE);
	}
	
	free(scrolltext);
	
	/* Clear screen and return TRUE if Esc/Q/q pressed. */	
	if(keypress==1)
	  return 1;
	else {
      for(y=0,x=0;x<2000;x++)  {
			y+=2+random()%300;
			gl_hline(0,y%480,639,2);
		}
		return 0;
	}
}
