/*
 *	Tykkipeli 2
 *	Misc functions that are used throughout the game.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <game_screen.h>
#include <players.h>

#include <hr_defines.h>
#include <hr_general.h>
#include <hr_bobs.h>
#include <hr_bitmaps.h>


/* Returns 1 if war is on... */
int war_is_on() {
	struct player *p=firstplayer;
	int c=0;
	while(p!=NULL) {		
		if((p->flags) & ALIVE) c++;
		p=p->next;
	}
	if(c>1)	  
	  return 1;
	else
	  return 0;
}


/* Returns pointer to string containing current gravity description.
 * Used by option_screen and control_panel's info_window*/
unsigned char *gravity_string() {
	sprintf(buffer,"%.2fg",(double)g/(double)DEF_G);
	return buffer;
}


/* Returns string describing current computer player intelligence settings.*/
unsigned char *percentage_string(int val,int def) {
	if(val==def)
	  sprintf(buffer,"Normal");
	else
	  sprintf(buffer,"%d%%",(val*100)/def);
	return buffer;
}
