/*
 *	Tykkipeli 2 end-of-game screen
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <tp2.h>
#include <game_screen.h>
#include <players.h>

#include <hr_screens.h>
#include <hr_mouse.h>
#include <hr_bobs.h>
#include <hr_fonts.h>
#include <hr_defines.h>
#include <hr_general.h>
#include <hr_input_handler.h>
#include <hr_keyboard.h>


void outro(unsigned char *text,int r,int g,int b){
	unsigned char *sp,*dp,*subliminal;
	int x,y,z,cs_len,w1,w2=0,h2=0,a=0,l,cs=1,mode,y2;
	int radius,dotc=0,a2,xp,yp,c;
	unsigned char *circlescroller="... All hail the Conqueror!...";
	cs_len=strlen(circlescroller);
	
	if(text==NULL) {
		cs=0;
		text="No winner?";
	}
	
	/* Open a screen and create a virtual gfx context.*/
	hr_screen_open(G320x200x256,SCREEN_VIRTUAL);
	
	hr_default_palette();
	gl_setpalettecolor(66,r,g,b);				/* Zoomer background */
	gl_setpalettecolor(67,10,10,10);			/* "click mouse" */
	gl_setpalettecolor(0,0,0,0);
	/* Zoomer grayshades */
	for(a=0;a<8;a++)
	  gl_setpalettecolor(16+a,15+a*3,15+a*3,15+a*3);
	gl_setpalettecolor(32,50,50,50);			/* Circle Scroller */
	for(a=0;a<64;a++)
	  gl_setpalettecolor(192+a,0,0,63-a);
	
	gl_clearscreen(66);
	
	w1=strlen(text)*8+2;
	hr_input_handler(NULL,NULL,AMB_RELEASED);
	/* Source bitmap */
	sp=malloc(w1*9);
	/* Destination bitmap. Should be at least enough :-) */
	dp=malloc(320*200);
	hr_monowrite(1,1,1,0,text,hr.font8x8,NONE);
	/* Add grayshade slide to text */
	for(y=0;y<(hr.font8x8->height);y++) {
		for(x=0;x<strlen(text)*(hr.font8x8->width);x++){
			if(gl_getpixel(x+1,y+1)==1)
			  gl_setpixel(x+1,y+1,16+y);
		}
	}
	gl_getbox(0,0,w1,9,sp);
	/* (154*17)==2618 */
	/* Get subliminal message */
	subliminal=malloc(2618);
	hr_monowrite(1,101,1,0,"Subliminal Message:",hr.font8x8,NONE);
	hr_monowrite(19,109,1,0,"Send me money!",hr.font8x8,NONE);
	gl_getbox(0,100,154,17,subliminal);
	
	/* Random mode.*/
	mode=random()%2;
	
	buffer[1]=0;								/* This is for circle scroller */
	y=l=0;

	hr_clearkey();
	hr_update_mouse(NONE,BOB_INIT);
	while(!(HR_LMB) &&
			!(HR_RMB) &&
			!(hr_getkey()))
		{
			gl_clearscreen(0);
			++gfx_counter;
#define CIRCLE_STEP    5
#define CIRCLE_DENSITY 40
#define CIRCLE_AMOUNT  20
#define DIVIDER (46+CIRCLE_AMOUNT*CIRCLE_DENSITY)
			switch(mode){
			 case 0:				
				/* Dot tunnel (sort of) */
				++dotc;
				for(x=1;x<CIRCLE_AMOUNT;x++){				
					z=(44+x*CIRCLE_DENSITY-(dotc%CIRCLE_DENSITY));
					radius=10+15000/z;
					c=192+(z*63)/DIVIDER;
					for(a2=0;a2<=45;a2+=CIRCLE_STEP){
						xp=pcos[a2]/((1<<SCALE)/radius);
						yp=psin[a2]/((1<<SCALE)/radius);
						gl_setpixel(160+xp,100+yp,c);
						gl_setpixel(160-xp,100+yp,c);
						gl_setpixel(160+xp,100-yp,c);
						gl_setpixel(160-xp,100-yp,c);
						/* Swap x and y.*/
						gl_setpixel(160+yp,100+xp,c);
						gl_setpixel(160-yp,100+xp,c);
						gl_setpixel(160+yp,100-xp,c);
						gl_setpixel(160-yp,100-xp,c);
					}				
				}
				break;
			 case 1:
				/* Boxes */
				yp=psin[gfx_counter%180];
				for(x=0;x<8;x++) {					
					z=(44+x*40-(l%40));
					y2=5000/z;
					c=192+(z*63)/324;
					xp=(y2*yp)>>SCALE;
					/* Top/bottom*/
					gl_hline(160-xp,100+xp,160+xp,c);
					gl_hline(160-xp,100-xp,160+xp,c);
					/* Sides */
					gl_line(160-xp,100-xp,160-xp,100+xp,c);
					gl_line(160+xp,100-xp,160+xp,100+xp,c);
				}
				break;
			}
			if(++a>179)
			  a=0;
			w2=MAX(4,(psin[a]*260)>>SCALE);
			h2=MAX(2,(psin[a]*80)>>SCALE);
			++l;
			HR_CENTER(160,192,67,0,"click mouse",hr.font8x8,NONE);
			/* Zooming text */
			if(gfx_counter%666>10)
			  /* Normal */
			  gl_scalebox(w1,9,sp,w2,h2,dp);
			else
			  /* Subliminal message */
			  gl_scalebox(154,17,subliminal,w2,h2,dp);
			/* Draw it */
			gl_putbox(160-w2/2,100-h2/2,w2,h2,dp);
			/* Circle Scroller */
			if(cs) {
				--y; if(y<0)y=359;
				for(x=0;x<cs_len;x++) {
					buffer[0]=*(circlescroller+x);   /* Copy char */
					hr_monowrite(156+((pcos[(y+x*5)%360]*150)>>SCALE),
									 96+((psin[(y+x*5)%360]*90)>>SCALE),
									 32,0,buffer,hr.font8x8,NONE);
				}
			}
			hr_update_mouse(NONE,BOB_DUMB);
			vga_waitretrace();
			gl_copyscreen(hr.physicalscreen);
		}
	hr_update_mouse(NONE,BOB_REMOVE);
	hr_screen_close(hr.active_screen);
	free(sp);
	free(dp);
	free(subliminal);
}
