extern struct shield_list{
	struct shield_list *next;
	struct shield *type;
	int amount;
}dummy_shield_list;

extern struct weapon_list{
	struct weapon_list *next;
	struct weapon *type;
	int amount;
}dummy_weapon_list;

extern struct player {
	struct player *next;
	unsigned char *name;
	int  flags;
	int  rosterindex;
	int  damage;
	int  old_wealth;
	int  wealth;
	int  rounds_won;
	int  kills;
	int  deaths;
	int  suicides;
	
	struct weapon      *active_weapon;
	struct weapon_list *weapons;
   struct shield      *active_shield;
	struct shield_list *shields;
	
	int  angle;
	int  power;
	int  x;
	int  y;
	int  firstcolor;
	int  britecolor;
	int  darkcolor;
	struct hr_bitmap *bitmap;
	struct hr_bitmap *deadmap;
	struct hr_bitmap *tempmap;
}dummy_player;

extern struct {
	int flags;
	unsigned char *name;
	unsigned int  games;
	unsigned int  won;
	unsigned int  kills;
	unsigned int  deaths;
	unsigned int  suicides;
	
   unsigned int default_weapon;
   unsigned int default_shield;

	struct hr_bitmap *bitmap;
	struct hr_bitmap *deadmap;
} roster[];

extern void init_roster();
extern void init_droids();
extern struct player *one_with_best_ratio();
extern void death(struct player *p);
extern void hurt(struct player *p,struct player *owner,int d,int damagetype);
extern void delete_all_players();
extern int magic_ratio(int deaths,int kills,int suicides);
extern struct player *create_player(int rosterindex,
												unsigned char *name,
												struct hr_bitmap *bitmap,
												struct hr_bitmap *deadmap,
												int flags);
extern void save_roster();
extern void set_player_colors();
