/*
 *	Tykkipeli 2
 *	by K.Veijalainen
 *
 *	Main game loop.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

#include <defines.h>
#include <parse_args.h>
#include <game_screen.h>
#include <players.h>
#include <init_exit.h>
#include <artificial_stupidity.h>
#include <bullets.h>
#include <misc.h>
#include <intro.h>
#include <outro.h>
#include <control_panel.h>
#include <option_screen.h>
#include <shop.h>
#include <hall_of_fame.h>
#include <weapons.h>

#include <hr_general.h>

/* Shitloads of globals...*/
unsigned char buffer[BUFFER_SIZE],
              *tp2_datapath;

int round_n,player_n,gfx_counter,scrolltext_counter,
    ammo_money,shots_fired,winning_money,start_money,interest,round,turn,
    g,wind,windmode,bumpiness,edges,
    droids,droid_sq;

long land_total;

unsigned long game_flags;
unsigned int oneliner_n;

struct hr_color *temp_colors;

unsigned char **oneliners,
              *game_screen;

unsigned char *instructions,
              *game_palette,
              *droid_name;
struct hr_bitmap *droid_bitmap,
                 *droid_deadmap,
                 *logo;

struct hr_bitmap *crosshairs_bitmap;

struct hr_bob *crosshairs;

unsigned int weapon_n,
             warhead_n,
             shield_n;

struct player  *firstplayer;
struct weapon  *firstweapon;
struct warhead *firstwarhead;
struct shield  *firstshield;
struct bullet  *firstbullet;

struct player *active_player;

struct warhead death_s;
struct weapon  death2_s;
struct warhead particle_s;

unsigned char *edgetext[]= {
	"Normal",
	  "Wrap",
	  "Bouncy",
	  "Random"
};

unsigned char *windtext[]={
	"None",
	  "Light",
	  "Normal",
	  "Heavy"
};


/*
 * Main game loop.
 */
int main(int argc,unsigned char *argv[]) {
	int p,l,l2,quit;
	/* Give up root privileges and init stuff.*/
	hr_init((game_flags & QUIET)?(1):(0));
	/* Default values etc.*/
	defaults();
	/**/
	if(parse_args(argc,argv))
	  exit(0);
	/**/
	startup_stuff();
	/* Main loop */
	quit=intro();
	while(!quit){
		switch(option_screen()){
		 case 3:
			/* Quit */
			quit=1;
			break;
		 case 2:
			/* Hall of Fame.*/
			hall_of_fame();
			break;
		 case 1:
			/* Back to intro....*/
			quit=intro();
			break;
		 case 0:
			/* player_n is calculated here.*/
			pre_game_inits();
			for(round=0;round<round_n;round++){
				if(!(game_flags & GAME_ABORTED)){
					if(game_flags & SHOPPING)
					  shop();
					if(!(game_flags & GAME_ABORTED))
					  pre_round_inits();
					turn=0;
					while(war_is_on() && !(game_flags & GAME_ABORTED)) {
						/*TURN_DONEs toggled off here*/
						pre_turn_inits();
						/**/
						active_player=firstplayer;
						for(l=0;l<player_n;l++){
							if(!(game_flags & GAME_ABORTED)){							
								/* Random player. If TURN_DONE flag is not set,
								 * immediately */
								if(game_flags & RANDOM_ORDER){
									do{
										/* Player number p is the one.*/
										p=random()%player_n;
										/* Now get pointer to player number p.*/
										active_player=firstplayer;
										for(l2=0;l2<p;l2++)
										  active_player=active_player->next;
									}while(active_player->flags & TURN_DONE);
								}
								/* Play! */
								if(active_player->flags & ALIVE) {
									pre_player_inits(active_player);
									if(active_player->flags & DROID)
									  auto_control(active_player);
									else
									  control_handler(active_player);
									if(!(game_flags & GAME_ABORTED))
									  fire_handler(active_player);
								}
								/* Either set TURN_DONE flag,
								 * or select next player.*/
								if(game_flags & RANDOM_ORDER)
								  active_player->flags |= TURN_DONE;
								else
								  active_player=active_player->next;
							}
						}
						if(!(game_flags & GAME_ABORTED)){
							post_players_stuff();
							gl_setclippingwindow(0,0,MAX_X,MAX_Y);
							/* Everything is handled in fly_bullets().*/
							fly_bullets();
							/**/
							post_turn_stuff();
							gl_setclippingwindow(0,0,MAX_X,S_HEIGHT-1);
						}
					}
					post_round_stuff();
				}
			}			
			post_game_stuff();
			break;
		}
	}
	exit_stuff();
	exit(0);
}
